import { PickToken } from "./PickTokenExtractor";

type propName = "QR" | "partNo" | "caseNo" | "baBy";

export class InvoiceControl {
	public reset(): void {
		this.QR = null;
		this.caseNo = null;
		this.partNo = null;
		this.latestScanned = null;
		this.baBy = null;
	}
	public set(args: InvoiceControlSetValue) {
		if (args.propName == "QR" && args.value instanceof PickToken)
			this.QR = args.value;

		if (args.propName == "caseNo" && args.value instanceof CaseNo)
			this.caseNo = args.value;

		if (args.propName == "partNo" && typeof args.value == "string")
			this.partNo = args.value;

		if (args.propName == "baBy" && typeof args.value == "string")
			this.baBy = args.value;

		this.latestScanned = args.propName
	}
	public QR: PickToken;
	public caseNo: CaseNo;
	public partNo: string;
	public latestScanned: propName;
	public baBy : string;
}
export class InvoiceControlSetValue {
	public propName: propName;
	public value: PickToken | CaseNo | string;
}

export class CaseNo {
	public constructor(caseno: string, casedate: string, casetype?:'BOX' | 'BAG') {
		this.caseNo = caseno;
		this.caseDate = casedate;
		
		if(casetype)
			this.caseType = casetype;
	}
	
	public caseNo: string;
	public caseDate: string;
	public caseType?: 'BOX' | 'BAG';
}