import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { HttpClientModule } from '@angular/common/http';
import { ReactiveFormsModule, FormsModule } from '@angular/forms';
import { RouterModule } from '@angular/router';

import { SharedComponentModule } from '../shared/shared-component.module';
import { AuthGuard } from 'src/app/core/auth-guard.service';

import { DomSaleComponent } from '../../pages/domsale/domsale.component';
import { DAILYREPComponent } from '../../pages/domsale/DAILYREP/DAILYREP.component';
import { MONTHREPComponent } from '../../pages/domsale/MONTHREP/MONTHREP.component';
import { NTAGZComponent } from '../../pages/domsale/NTAG_Z/NTAG_Z.component';
import { SNBA007AComponent } from '../../pages/domsale/SNBA007_A/SNBA007_A.component';
// import { SNIE001MComponent } from '../../pages/domsale/SNIE001_M/SNIE001_M.component';
import { SNM017PComponent } from '../../pages/domsale/SNM017P/SNM017P.component';
import { SNM013PComponent } from '../../pages/domsale/SNM013P/SNM013P.component';
// import { SNM082PComponent } from '../../pages/domsale/SNM082P/SNM082P.component';
import { SNM100PComponent } from '../../pages/domsale/SNM100P/SNM100P.component';
import { SNJF003Component } from '../../pages/domsale/SNJF003/SNJF003.component';
// import { SNPP101_SAPComponent } from '../../pages/domsale/SNPP101_SAP/SNPP101_SAP.component';
// import { SNPP101_SAPEComponent } from '../../pages/domsale/SNPP101_SAPE/SNPP101_SAPE.component';
// import { SNPP106_NComponent } from '../../pages/domsale/SNPP106_N/SNPP106_N.component';
// import { SNPP106_NEComponent } from '../../pages/domsale/SNPP106_NE/SNPP106_NE.component';
// import { SNSD148_FComponent } from '../../pages/domsale/SNSD148_F/SNSD148_F.component';
// import { SNSD201Component } from '../../pages/domsale/SNSD201/SNSD201.component';
import { SNSE003Component } from '../../pages/domsale/SNSE003/SNSE003.component';
import { SNSE004_MComponent } from '../../pages/domsale/SNSE004_M/SNSE004_M.component';
import { SNSE004_AComponent } from '../../pages/domsale/SNSE004_A/SNSE004_A.component';
import { SNSE004_DComponent } from '../../pages/domsale/SNSE004_D/SNSE004_D.component';
import { SNSE223Component } from '../../pages/domsale/SNSE223/SNSE223.component';
import { SNSE015_DComponent } from '../../pages/domsale/SNSE015_D/SNSE015_D.component';
// import { SNSE042cComponent } from '../../pages/domsale/SNSE042_C/SNSE042_C.component';
import { SNSE063_A4Component } from '../../pages/domsale/SNSE063_A4/SNSE063_A4.component';
import { SNSE068Component } from '../../pages/domsale/SNSE068/SNSE068.component';
// import { SNSE069MComponent } from '../../pages/domsale/SNSE069_M/SNSE069_M.component';
// import { SNSE140Component } from '../../pages/domsale/SNSE140/SNSE140.component';
// import { SNSE141Component } from '../../pages/domsale/SNSE141/SNSE141.component';
import { SNSE142Component } from '../../pages/domsale/SNSE142/SNSE142.component';
// import { SNSE151Component } from '../../pages/domsale/SNSE151/SNSE151.component';
// import { SNSE152Component } from '../../pages/domsale/SNSE152/SNSE152.component';
// import { SNSE153Component } from '../../pages/domsale/SNSE153/SNSE153.component';
// import { SNSE154Component } from '../../pages/domsale/SNSE154/SNSE154.component';
// import { SNSE160Component } from '../../pages/domsale/SNSE160/SNSE160.component';
import { SNSE163Component } from '../../pages/domsale/SNSE163/SNSE163.component';
import { SNSE152Component } from '../../pages/domsale/SNSE152/SNSE152.component';
import { SNSR063F_A4Component } from '../../pages/domsale/SNSR063F_A4/SNSR063F_A4.component';
import { SNSQ092Component } from '../../pages/domsale/SNSQ092/SNSQ092.component';
// import { SNSQ091Component } from '../../pages/domsale/SNSQ091/SNSQ091.component';
import { SNSE198Component } from '../../pages/domsale/SNSE198/SNSE198.component';
import { MaterialImportModule } from '../shared/material.module';
import { RoleResolver } from 'src/app/core/role-resolver.service';
import { SNSE005_NComponent } from 'src/app/pages/saleorder/SNSE005 _N/SNSE005_N.component';
import { SNSE011_NComponent } from 'src/app/pages/domsale/SNSE011_N/SNSE011_N.component';
import { SNIE001_NComponent } from 'src/app/pages/domsale/SNIE001_N/SNIE001_N.component';
import { SaleOrderModule } from '../saleorder/saleorder.module';
import { SNSE004_M_BOComponent } from 'src/app/pages/domsale/SNSE004_M/bo_eo/SNSE004_M_BO.component';
import { SNSE004_A_BOComponent } from 'src/app/pages/domsale/SNSE004_A/bo_eo/SNSE004_A_BO.component';
import { SNSE004_D_BOComponent } from 'src/app/pages/domsale/SNSE004_D/bo_eo/SNSE004_D_BO.component';
import { SNSE223_BOComponent } from 'src/app/pages/domsale/SNSE223/bo_eo/SNSE223_BO.component';
import { SNSE009Component } from 'src/app/pages/domsale/SNSE009/SNSE009.component';
import { SNSE009RComponent } from 'src/app/pages/domsale/SNSE009R/SNSE009R.component';
import { SNSE009MComponent } from 'src/app/pages/domsale/SNSE009M/SNSE009M.component';
import { SNSE010RComponent } from 'src/app/pages/domsale/SNSE010R/SNSE010R.component';
import { SNSE011RComponent } from 'src/app/pages/domsale/SNSE011R/SNSE011R.component';

import { SNSE019Component } from 'src/app/pages/domsale/SNSE019/SNSE019.component';
import { RunBat1Component } from 'src/app/pages/domsale/RUNBAT1/runbat1.component';
import { RunBat1_BRComponent } from 'src/app/pages/domsale/RUNBAT1_BR/RUNBAT1_BR.component';
import { SNSE204_DComponent } from 'src/app/pages/domsale/SNSE204_D/SNSE204_D.component';
import { SNSE015_VComponent } from 'src/app/pages/domsale/SNSE015_V/SNSE015_V.component';
import { SNSE015_VWComponent } from 'src/app/pages/domsale/SNSE015_VW/SNSE015_VW.component';
import { SNSE204_PComponent } from 'src/app/pages/domsale/SNSE204_P/SNSE204_P.component';
import { SNSE204Component } from 'src/app/pages/domsale/SNSE204/SNSE204.component';
import { SNSE204_SComponent } from 'src/app/pages/domsale/SNSE204_S/SNSE204_S.component';
import { SNSE205Component } from 'src/app/pages/domsale/SNSE205/SNSE205.component';
import { SNIE001_NReverseComponent } from 'src/app/pages/domsale/SNIE001_N/Reverse/SNIE001_N-Reverse.component';
import { SNSE208Component } from 'src/app/pages/domsale/SNSE208/SNSE208.component';
import { SNSE210Component } from 'src/app/pages/domsale/SNSE210/SNSE210.component';
import { SNSE219Component } from 'src/app/pages/domsale/SNSE219/SNSE219.component';
import { SNSE222Component } from 'src/app/pages/domsale/SNSE222/SNSE222.component';
import { SNSE063R_A4Component } from 'src/app/pages/domsale/SNSE063R_A4/SNSE063R_A4.component';
import { SNSE211Component } from 'src/app/pages/domsale/SNSE211/SNSE211.component';
import { SNSE015_WComponent } from '../../pages/domsale/SNSE015_W/SNSE015_W.component';
import { RUNBAT1_WComponent } from 'src/app/pages/domsale/RUNBAT1_W/RUNBAT1_W.component';
import { SNSE221Component } from 'src/app/pages/domsale/SNSE221/SNSE221.component';

@NgModule({
  declarations: [
    DomSaleComponent,
    SNSE204Component,
    SNSE204_DComponent,
    SNSE204_PComponent,
    DAILYREPComponent,
    MONTHREPComponent,
    SNSE005_NComponent,
    NTAGZComponent,
    SNBA007AComponent,
    // SNIE001MComponent,
    // SNIE002Component,
    SNM017PComponent,
    SNM013PComponent,
    // SNM082PComponent,
    SNM100PComponent,
    SNJF003Component,
    // SNPP101_SAPComponent,
    // SNPP101_SAPEComponent,
    // SNPP106_NComponent,
    // SNPP106_NEComponent,
    // SNSD148_FComponent,
    // SNSD201Component,
    SNSE003Component,
    SNSE004_MComponent,
    SNSE004_AComponent,
    SNSE004_M_BOComponent,
    SNSE223Component,
    SNSE223_BOComponent,
    SNSE004_A_BOComponent,
    SNSE004_DComponent,
    SNSE004_D_BOComponent,
    SNSE015_DComponent,
    // SNSE041_M2Component,
    // SNSE042cComponent,
    SNSE063_A4Component,
    SNSE068Component,
    // SNSE069MComponent,
    // SNSE140Component,
    // SNSE141Component,
    SNSE142Component,
    // SNSE151Component,
    // SNSE152Component,
    // SNSE153Component,
    // SNSE154Component,
    // SNSE160Component,
    SNSE163Component,
    SNSE152Component,
    SNSR063F_A4Component,
    SNSQ092Component,
    // SNSQ091Component,
    SNSE198Component,
    SNSE011_NComponent,
    SNIE001_NComponent,
    SNIE001_NReverseComponent,
    SNSE009Component,
    SNSE009RComponent,
    SNSE009MComponent,
    SNSE010RComponent,
    SNSE011RComponent,
    SNSE019Component,
    RunBat1Component,
    RunBat1_BRComponent,
    SNSE015_VComponent,
    SNSE015_VWComponent,
    SNSE204_SComponent,
    SNSE205Component,
    SNSE208Component,
    SNSE210Component,
    SNSE219Component,
    SNSE222Component,
    SNSE063R_A4Component,
    SNSE211Component,
    SNSE015_WComponent,
    RUNBAT1_WComponent,
    SNSE221Component
  ],
  imports: [
    CommonModule,
    HttpClientModule,
    FormsModule,
    ReactiveFormsModule,
    SharedComponentModule,
    FormsModule,
    SaleOrderModule,

    //Material imports
    MaterialImportModule,

    RouterModule.forChild([
      {
        path: '',
        component: DomSaleComponent,
        children: [
          {
            path: 'SNSE221',
            component: SNSE221Component,
            resolve: {
              role: RoleResolver
            }
          },
          {
            path: 'SNSE204',
            component: SNSE204Component,
            resolve: {
              role: RoleResolver
            }
          },
          {
            path: 'SNSE204_P',
            component: SNSE204_PComponent,
            resolve: {
              role: RoleResolver
            }
          },
          {
            path: 'SNSE204_D',
            component: SNSE204_DComponent,
            resolve: {
              role: RoleResolver
            }
          },
          {
            path: 'SNSE005_N',
            component: SNSE005_NComponent,
            resolve: {
              role: RoleResolver
            }
          },
          {
            path: 'DAILYREP',
            component: DAILYREPComponent,
            resolve: {
              role: RoleResolver
            },
          },
          {
            path: 'MONTHREP',
            component: MONTHREPComponent,
            resolve: {
              role: RoleResolver
            },
          },
          {
            path: 'NTAG_Z',
            component: NTAGZComponent,
            resolve: {
              role: RoleResolver
            },
          },
          {
            path: 'SNBA007_A',
            component: SNBA007AComponent,
            resolve: {
              role: RoleResolver
            },
          },

          {
            path: 'SNM013P',
            component: SNM013PComponent,
            resolve: {
              role: RoleResolver
            },
          },
          {
            path: 'SNM017P',
            component: SNM017PComponent,
            resolve: {
              role: RoleResolver
            },
          },
          // {
          //     path: 'SNM082P',
          //     component: SNM082PComponent,
          //     resolve: {
          //         role: RoleResolver
          //     },
          // },
          {
            path: 'SNM100P',
            component: SNM100PComponent,
            resolve: {
              role: RoleResolver
            },
          },
          {
            path: 'SNJF003',
            component: SNJF003Component,
            resolve: {
              role: RoleResolver
            },
          },
          // {
          //     path: 'SNPP101_SAP',
          //     component: SNPP101_SAPComponent,
          //     resolve: {
          //         role: RoleResolver
          //     },
          // },
          // {
          //     path: 'SNPP101_SAPE',
          //     component: SNPP101_SAPEComponent,
          //     resolve: {
          //         role: RoleResolver
          //     },
          // },
          // {
          //     path: 'SNPP106_N',
          //     component: SNPP106_NComponent,
          //     resolve: {
          //         role: RoleResolver
          //     },
          // },
          // {
          //     path: 'SNPP106_NE',
          //     component: SNPP106_NEComponent,
          //     resolve: {
          //         role: RoleResolver
          //     },
          // },
          // {
          //     path: 'SNSD148_F',
          //     component: SNSD148_FComponent,
          //     resolve: {
          //         role: RoleResolver
          //     },
          // },
          // {
          //     path: 'SNSD201',
          //     component: SNSD201Component,
          //     resolve: {
          //         role: RoleResolver
          //     },
          // },
          {
            path: 'SNSE003',
            component: SNSE003Component,
            resolve: {
              role: RoleResolver
            },
          },
          {
            path: 'SNSE004_M',
            component: SNSE004_MComponent,
            resolve: {
              role: RoleResolver
            },
          },
          {
            path: 'SNSE004_A',
            component: SNSE004_AComponent,
            resolve: {
              role: RoleResolver
            },
          },
          {
            path: 'SNSE004_D',
            component: SNSE004_DComponent,
            resolve: {
              role: RoleResolver
            },
          },
          {
            path: 'SNSE223',
            component: SNSE223Component,
            resolve: {
              role: RoleResolver
            },
          },
          {
            path: 'SNSE015_D',
            component: SNSE015_DComponent,
            resolve: {
              role: RoleResolver
            },
          },
          // {
          //     path: 'SNSE041_M2',
          //     component: SNSE041_M2Component,
          //     resolve: {
          //         role: RoleResolver
          //     },
          // },
          // {
          //     path: 'SNSE042_C',
          //     component: SNSE042cComponent,
          //     resolve: {
          //         role: RoleResolver
          //     },
          // },
          {
            path: 'SNSE063_A4',
            component: SNSE063_A4Component,
            resolve: {
              role: RoleResolver
            },
          },
          {
            path: 'SNSE068',
            component: SNSE068Component,
            resolve: {
              role: RoleResolver
            },
          },
          // {
          //     path: 'SNSE069M',
          //     component: SNSE069MComponent,
          //     resolve: {
          //         role: RoleResolver
          //     },
          // },
          // {
          //     path: 'SNSE140',
          //     component: SNSE140Component,
          //     resolve: {
          //         role: RoleResolver
          //     },
          // },
          // {
          //     path: 'SNSE141',
          //     component: SNSE141Component,
          //     resolve: {
          //         role: RoleResolver
          //     },
          // },
          {
              path: 'SNSE142',
              component: SNSE142Component,
              resolve: {
                  role: RoleResolver
              },
          },
          // {
          //     path: 'SNSE151',
          //     component: SNSE151Component,
          //     resolve: {
          //         role: RoleResolver
          //     },
          // },
          // {
          //     path: 'SNSE152',
          //     component: SNSE152Component,
          //     resolve: {
          //         role: RoleResolver
          //     },
          // },
          // {
          //     path: 'SNSE153',
          //     component: SNSE153Component,
          //     resolve: {
          //         role: RoleResolver
          //     },
          // },
          // {
          //     path: 'SNSE154',
          //     component: SNSE154Component,
          //     resolve: {
          //         role: RoleResolver
          //     },
          // },
          // {
          //     path: 'SNSE160',
          //     component: SNSE160Component,
          //     resolve: {
          //         role: RoleResolver
          //     },
          // },
          {
            path: 'SNSE163',
            component: SNSE163Component,
            resolve: {
              role: RoleResolver
            },
          },
          {
            path: 'SNSE152',
            component: SNSE152Component,
            resolve: {
              role: RoleResolver
            },
          },
          {
            path: 'SNSR063F_A4',
            component: SNSR063F_A4Component,
            resolve: {
              role: RoleResolver
            },
          },
          {
            path: 'SNSQ092',
            component: SNSQ092Component,
            resolve: {
              role: RoleResolver
            },
          },
          // {
          //     path: 'SNSQ091',
          //     component: SNSQ091Component,
          //     resolve: {
          //         role: RoleResolver
          //     },
          // },
          {
            path: 'SNSE198',
            component: SNSE198Component,
            resolve: {
              role: RoleResolver
            },
          },
          {
            path: 'SNSE011_N',
            component: SNSE011_NComponent,
            resolve: {
              role: RoleResolver
            },
          },
          {
            path: 'SNIE001_N',
            component: SNIE001_NComponent,
            resolve: {
              role: RoleResolver
            },
          },
          {
            path: 'SNSE011R',
            component: SNSE011RComponent,
            resolve: {
              role: RoleResolver
            },
          },
          {
            path: 'SNSE010R',
            component: SNSE010RComponent,
            resolve: {
              role: RoleResolver
            },
          },
          {
            path: 'SNSE009R',
            component: SNSE009RComponent,
            resolve: {
              role: RoleResolver
            },
          },
          {
            path: 'SNSE009',
            component: SNSE009Component,
            resolve: {
              role: RoleResolver
            },
          },
          {
            path: 'SNSE009M',
            component: SNSE009MComponent,
            resolve: {
              role: RoleResolver
            },
          },
          {
            path: 'SNSE019',
            component: SNSE019Component,
            resolve: {
              role: RoleResolver
            },
          },
          {
            path: 'RUNBAT1',
            component: RunBat1Component,
            resolve: {
              role: RoleResolver
            }
          },
          {
            path: 'RUNBAT1_BR',
            component: RunBat1_BRComponent,
            resolve: {
              role: RoleResolver
            }
          },
          {
            path: 'SNSE015_V',
            component: SNSE015_VComponent,
            resolve: {
              role: RoleResolver
            }
          },
          {
            path: 'SNSE015_VW',
            component: SNSE015_VWComponent,
            resolve: {
              role: RoleResolver
            }
          },
          {
            path: 'SNSE204_S',
            component: SNSE204_SComponent,
            resolve: {
              role: RoleResolver
            }
          },
          {
            path: 'SNSE205',
            component: SNSE205Component,
            resolve: {
              role: RoleResolver
            }
          },
          {
            path: 'SNSE208',
            component: SNSE208Component,
            resolve: {
              role: RoleResolver
            }
          },
             {
            path: 'SNSE210',
            component: SNSE210Component,
            resolve: {
              role: RoleResolver
            }
          },
          {
            path: 'SNSE219',
            component: SNSE219Component,
            resolve: {
              role: RoleResolver
            }
          },
          {
            path: 'SNSE222',
            component: SNSE222Component,
            resolve: {
              role: RoleResolver
            }
          },
          {
            path: 'SNSE063R_A4',
            component: SNSE063R_A4Component,
            resolve: {
              role: RoleResolver
            }
          },
          {
            path: 'SNSE211',
            component: SNSE211Component,
            resolve: {
              role: RoleResolver
          }
          },
          {
            path: 'SNSE015_W',
            component: SNSE015_WComponent,
            resolve: {
              role: RoleResolver
            }
          },
          {
            path: 'RUNBAT1_W',
            component: RUNBAT1_WComponent,
            resolve: {
              role: RoleResolver
            }
          },
        ],
        canActivate: [AuthGuard]
      }
    ])
  ],
  exports: [SNSE004_M_BOComponent, SNSE004_A_BOComponent, SNSE004_D_BOComponent, SNSE223_BOComponent],
  providers: [AuthGuard, RoleResolver],
})
export class DomSalesModule { }

