import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { HttpClientModule } from '@angular/common/http';
import { ReactiveFormsModule, FormsModule } from '@angular/forms';
import { RouterModule } from '@angular/router';
import { SharedComponentModule } from '../shared/shared-component.module';
import { AuthGuard } from 'src/app/core/auth-guard.service';
import { MaterialImportModule } from '../shared/material.module';
import { RoleResolver } from 'src/app/core/role-resolver.service';
import { PartsCenterComponent } from 'src/app/pages/partscenter/partscenter.component';
import { SNEN001Component } from 'src/app/pages/partscenter/SNEN001/SNEN001.component';

import { SNEN005Component } from 'src/app/pages/partscenter/SNEN005/SNEN005.component';


import { SNEN051Component } from 'src/app/pages/partscenter/SNEN051/SNEN051.component';

import { SNEN024Component } from 'src/app/pages/partscenter/SNEN024/SNEN024.component';
import { SNEN003Component } from 'src/app/pages/partscenter/SNEN003/SNEN003.component';
import { SNEN010Component } from 'src/app/pages/partscenter/SNEN010/SNEN010.component';
import { SNEN045Component } from 'src/app/pages/partscenter/SNEN045/SNEN045.component';
import { SNEN006Component } from 'src/app/pages/partscenter/SNEN006/SNEN006.component';
import { SNEN007Component } from 'src/app/pages/partscenter/SNEN007/SNEN007.component';
import { SNEN008Component } from 'src/app/pages/partscenter/SNEN008/SNEN008.component';
import { SNEN022Component } from 'src/app/pages/partscenter/SNEN022/SNEN022.component';
import { SNEN026Component } from 'src/app/pages/partscenter/SNEN026/SNEN026.component';
import { SNEN050Component } from 'src/app/pages/partscenter/SNEN050/SNEN050.component';
import { SNEN057Component } from 'src/app/pages/partscenter/SNEN057/SNEN057.component';
import { SNEN030Component } from 'src/app/pages/partscenter/SNEN030/SNEN030.component';




@NgModule({
  declarations: [

    PartsCenterComponent,
    SNEN001Component,
    SNEN045Component,

    SNEN003Component,

    SNEN005Component,

    SNEN051Component,
    SNEN024Component,
    SNEN010Component,
    SNEN030Component,
    SNEN006Component,
    SNEN007Component,
    SNEN008Component,
    SNEN022Component,
    SNEN024Component,
    SNEN026Component,
    SNEN050Component,
    SNEN051Component,
    SNEN057Component,
  ],
  imports: [
    CommonModule,
    HttpClientModule,
    FormsModule,
    ReactiveFormsModule,
    SharedComponentModule,
    FormsModule,

    //Material imports
    MaterialImportModule,



    RouterModule.forChild([
      {
        path: '',
        component: PartsCenterComponent,
        children: [
          {
            path: 'SNEN001',
            component: SNEN001Component,
          },

          {
            path: 'SNEN045',
            component: SNEN045Component,
          },

          {
            path: 'SNEN005',
            component: SNEN005Component,
          },

          {
            path: 'SNEN051',
            component: SNEN051Component,
          },

          {
            path: 'SNEN024',
            component: SNEN024Component,
          },
          {
            path: 'SNEN003',
            component: SNEN003Component,
          },
          {
            path: 'SNEN010',
            component: SNEN010Component,
          },
          {
            path: 'SNEN030',
            component: SNEN030Component,
          },
          {
            path: 'SNEN006',
            component: SNEN006Component,
          },
          {
            path: 'SNEN007',
            component: SNEN007Component,
          },
          {
            path: 'SNEN008',
            component: SNEN008Component,
          },

          {
            path: 'SNEN022',
            component: SNEN022Component,
          },
          {
            path: 'SNEN024',
            component: SNEN024Component,
          },
          {
            path: 'SNEN026',
            component: SNEN026Component,
          },


          {
            path: 'SNEN050',
            component: SNEN050Component,
          },
          {
            path: 'SNEN051',
            component: SNEN051Component,
          },

          {
            path: 'SNEN057',
            component: SNEN057Component,
          },
        ],
        //canActivate: [AuthGuard]
      }
    ])
  ],
  exports: [],
  providers: [AuthGuard, RoleResolver],
})
export class PartsCenterModule { }
