import { Component, OnInit, Input, Output, EventEmitter, TemplateRef, ContentChild, ViewChild, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Router } from '@angular/router';
import { Globals } from 'src/app/core/global';
import { ModalService } from '../../../core/modal.service';
import * as moment from 'moment';
import { DialogTemplateComponent } from 'src/app/components/shared/dialog-template/dialog-template.component';
import { AuthDecode } from 'src/app/core/auth-decode.service';
import { AuthService } from 'src/app/core/auth-service.service';
import { environment } from './../../../../environments/environment';
import { concat } from 'rxjs/operators';

@Component({
  selector: 'SNEN003',
  templateUrl: './SNEN003.component.html',
  styleUrls: ['./SNEN003.component.css']
})


export class SNEN003Component implements OnInit {
  public userName: string;
  public userCode: string;
  public userID: string;

  constructor(
    private http: HttpService,
    private router: Router,
    private modal: ModalService,
    private viewref: ViewContainerRef,
    private global: Globals,
    private auth: AuthDecode,
    private authService: AuthService
  ) { }

  public CustomerList: any = [];
  public param: any = {}
  public showList: Boolean;
  public showDetail: Boolean;
  public showDetail2: Boolean;
  public showDetail3: Boolean;
  public showDetail4: Boolean;
  public tableCheck: any = [];
  public tableCheck1: any = [];
  public formData: any = {};
  public tableData: any = [];
  public tableData1: any = [];
  public tableData2: any = [];
  public tableData3: any = [];
  public tableData4: any = [];
  public listTrans: any = [];
  public paramSearch: any = {};
  public paramsHead: any = {};
  public params: any = {};



  public summaryTotal: any[] = [
    {
      fieldName: 'PART_NAME',
      value: 'Total',
      show: true,
    },
    {
      fieldName: 'ORDER_QTY',
      show: true,
    },
    {
      fieldName: 'INV_QTY',
      show: true,
    },

  ];
  
  public summaryTotal1: any[] = [
    {
      fieldName: 'PART_NAME_TH',
      value: 'Total',
      show: true,
    },
    {
      fieldName: 'ORDER_QTY',
      show: true,
    },
    {
      fieldName: 'ACCEPT_QTY',
      show: true,
    },
    {
      fieldName: 'NET_AMT_B',
      show: true,
    },

  ];

  ngOnInit(): void {
    this.showList = true;
    this.showDetail = false;
    this.userName = this.authService.isAuthenticated() && this.auth.getDetail().ssNameTH;
    this.userCode = this.authService.isAuthenticated() && this.auth.getDetail().ssUserName;
   // this.Display();
    this.paramSearch.CUSTOMER_CODE = '';
    this.paramSearch.BRANCH_CODE = '';
    this.paramSearch.ORDER_NO = '';
  }

  //public Display() {
  //  this.tableCheck = [];
  //  const param = {
  //    CUSTOMER_CODE: this.paramSearch.CUSTOMER_CODE,
  //    BRANCH_CODE: this.paramSearch.BRANCH_CODE,
  //  };   
  //  this.http.post("PC", "SNEN003_CheckData", param)
  //    .subscribe(res => {
  //      this.tableCheck = res.Table;
  //      this.formData = this.tableCheck;     
  //    }, (err) => {
  //      console.log(err, 'err')
  //      this.modal.warning("Found an error, please contract support team", this.viewref);
  //    });
  //}

  public Search() {
    this.tableCheck = [];
    const param = {
      CUSTOMER_CODE: this.paramSearch.CUSTOMER_CODE,
      BRANCH_CODE: this.paramSearch.BRANCH_CODE,
    };
  //  console.log('param >>> ', param);
    this.http.post("PC", "SNEN003_CheckData", param)
      .subscribe(res => {
     //   console.log(res);
        this.tableCheck = res.Table;
        if (this.tableCheck.length > 0) {
          this.tableData = [];
          const params = {
            CUSTOMER_CODE: this.paramSearch.CUSTOMER_CODE,
            BRANCH_CODE: this.paramSearch.BRANCH_CODE,
            ORDER_NO: this.paramSearch.ORDER_NO
          };
        //  console.log('params> >', params);
          this.http.post("PC", "SNEN003_GetData", params)
            .subscribe(res => {
             console.log('res > ',res);
              this.tableData = res.Table;

              if (this.tableData.length > 0) {
                this.params.Customer_Code = this.tableData[0].CUSTOMER_CODE;
                this.params.Customer_Name = this.tableData[0].CUSTOMER_NAME;
                this.params.Branch_Code = this.tableData[0].BRANCH_CODE;
                this.params.Branch_Name2 = this.tableData[0].BRANCH_NAME2;
                this.showDetail = true;
                this.showList = false;
              } else {
                this.modal.info("!!! No Records !!!", this.viewref);
                return false;
              }
              
            }, (err) => {
              console.log(err, 'err')
              this.modal.warning("Found an error, please contract support team", this.viewref);
            });

        } else {
          this.modal.warning("!!! รหัสลูกค้า หรือรหัสสาขา ไม่ถูกต้อง !!!", this.viewref);
          return false;
        }

      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contract support team", this.viewref);
      });

   
  }

  public ViewSearch(data) {
    this.showDetail2 = true;
    this.showDetail = false;
    this.showList = false;
    this.tableData1 = [];
    this.paramsHead.CUSTOMER_NAME = data.CUSTOMER_CODE + ' ' + data.CUSTOMER_NAME_TH + ' ' + data.BRANCH_NAME_TH;
    this.paramsHead.ORDER_NO = data.ORDER_NO;
    this.paramsHead.ORDER_DATE = data.ORDER_DATE;
    const param = {
      CUSTOMER_CODE: data.CUSTOMER_CODE,
      BRANCH_CODE: data.BRANCH_CODE,
      ORDER_NO: data.ORDER_NO
    };
    this.http.post("PC", "SNEN003_GetData_Order_Part", param)
      .subscribe(res => {
        this.tableData1 = res.Table;
        this.tableData1 = this.tableData1.slice();   // หาผล Sum
        var remark = '';
        this.tableData1.forEach((d) => {
          if (d.ACCEPT_PART_NO != d.ORDER_PART_NO) {
            remark = d.ACCEPT_PART_NO;
          }
          d.ACCEPT_PART_NO = remark;

          //if (d.RCV_TIME != '') {
          //  d.RCV_TIME = d.RCV_TIME;
          //} else {
          //}
         
        })
        
      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contract support team", this.viewref);
      });
  }

  public MoreDetail() {
    //console.log('data >> ', this.tableData1);
    this.showDetail3 = true;
    this.showDetail2 = false;
    this.showDetail = false;
    this.showList = false;
    this.tableData2 = [];
    const param = {
      CUSTOMER_CODE: this.tableData1[0].CUSTOMER_CODE,
      ORDER_NO: this.tableData1[0].ORDER_NO
    };
    //console.log('param >> ', param);
    this.http.post("PC", "SNEN003_GetData_MoreDetail", param)
      .subscribe(res => {
      //  console.log('res >> ', res);
        this.tableData2 = res.Table;
        if (this.tableData2.length > 0) {
          this.paramsHead.CUSTOMER_CODE = this.tableData2[0].CUSTOMER_CODE;
          this.paramsHead.CUST_NAME_TH = this.tableData2[0].CUST_NAME_TH;
          this.paramsHead.ORDER_NO = this.tableData2[0].ORDER_NO;
          this.paramsHead.ORDER_DATE = this.tableData2[0].ORDER_DATE;
          this.paramsHead.ROUTE_CODE = this.tableData2[0].ROUTE_CODE;

          if (this.tableData2[0].DELIVERY_CODE != '') {
            if (this.tableData2[0].DELIVERY_CODE == '01') {
              this.paramsHead.DELIVERY_CODE = "รอรับทันที";
            } else if (this.tableData2[0].DELIVERY_CODE == '02') {
              this.paramsHead.DELIVERY_CODE = "รอรับ";
            } else if (this.tableData2[0].DELIVERY_CODE == '03') {

              this.listTrans = [];
              const param = {
                TRANSPORT_CODE: this.tableData2[0].TRANSPORT_CODE
              };
              this.http.post('PC', 'SNEN024_GetData_Transport', param).subscribe((res) => {
                //console.log(' res >>> > > ', res);
                this.listTrans = res.Table;

                if (this.listTrans[0].TRANS_NAME_EN != '') {
                  this.paramsHead.TRANSPORT_NAME = this.tableData2[0].DELIVERY_CODE + " " + this.listTrans[0].TRANS_NAME_EN + " " + " จัดส่ง ";
                } else {
                  this.paramsHead.TRANSPORT_NAME = this.tableData2[0].DELIVERY_CODE + " " + " จัดส่ง ";
                }

              });
            }
          }
        }
      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contract support team", this.viewref);
      });
  }

  public PrintPO() {
    this.showDetail4 = true;
    this.showDetail3 = false;
    this.showDetail2 = false;
    this.showDetail = false;
    this.showList = false;
    this.tableData3 = [];
    this.tableData4 = [];
    const param = {
      CUSTOMER_CODE: this.tableData1[0].CUSTOMER_CODE,
      ORDER_NO: this.tableData1[0].ORDER_NO
    };
    console.log(param,'<<<<<')
    this.http.post("PC", "SNEN003_GetData_PrintPO", param)
      .subscribe(res => {
        console.log(' >> > ',res);
        this.tableData3 = res.Table;
        this.tableData4 = res.Table1;
        this.tableData4 = this.tableData4.slice();   // หาผล Sum
        var reason = '';
        this.tableData4.forEach((d) => {
          if (d.STATUS_CODE == 'C') {
            reason = d.REASON_NAME_TH;
            d.NUM_REASON = 1;
          } else if (d.STATUS_CODE == 'B' && d.REASON_CODE == '514') {
            reason = "Back order สั่งเกินโควต้า";
            d.NUM_REASON = 2;
          } else {
            reason = d.REASON_NAME_TH;
            d.NUM_REASON = 2;
          }
          d.REASON_NAME_TH = reason;
          d.DISCOUNT_RATE = d.DISCOUNT_RATE1 + ',' + d.DISCOUNT_RATE2 + ',' + d.DISCOUNT_RATE3;
        })
      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contract support team", this.viewref);
      });
  }

  public Reset() {
    this.paramSearch.CUSTOMER_CODE = '';
    this.paramSearch.BRANCH_CODE = '';
    this.paramSearch.ORDER_NO = '';
  }

  public GoToList() {
    this.showList = true;
    this.showDetail = false;
  }

  public GoToList2() {
    this.showList = false;
    this.showDetail = true;
    this.showDetail2 = false;
  }

  public GoToList3() {
    this.showList = false;
    this.showDetail = false;
    this.showDetail2 = true;
    this.showDetail3 = false;
  }

  public GoToList4() {
    this.showList = false;
    this.showDetail = false;
    this.showDetail2 = false;
    this.showDetail3 = true;
    this.showDetail4 = false;
  }


}
