import { Component, OnInit, Input, Output, EventEmitter, TemplateRef, ContentChild, ViewChild, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Router } from '@angular/router';
import { Globals } from 'src/app/core/global';
import { ModalService } from '../../../core/modal.service';
import { AuthDecode } from 'src/app/core/auth-decode.service';
import { AuthService } from 'src/app/core/auth-service.service';
import * as moment from 'moment';

@Component({
  selector: 'SNEN006',
  templateUrl: './SNEN006.component.html',
  styleUrls: ['./SNEN006.component.css']
})


export class SNEN006Component implements OnInit {


  constructor(
    private http: HttpService,
    private router: Router,
    private modal: ModalService,
    private viewref: ViewContainerRef,
    private global: Globals,
    private auth: AuthDecode,
    private authService: AuthService,
  ) { }

  public CustomerList: any = [];
  public param: any = {}
  public paramSearch: any = {};
  public showList01: Boolean;
  public statusColor: any = {};
  public ssNameTH: string;
  public ssUserName: string;
  public Datatable: any = [];

  public Search() {
    if (this.paramSearch.PART_NO) {
      this.showList01 = true;
      this.Datatable = [];
      this.http.post("PC", "SNEN006_GetData", this.paramSearch)
        .subscribe(res => {
          console.log(res);
          this.Datatable = res.Table;
          console.log(this.Datatable);
          this.Datatable.forEach((x) => {
            if (x.LOCK_SALES == 117) {
              x.STATUS = "สอบถาม";
              this.statusColor = "Green";
            } else if (x.LOCK_SALES != 0) {
              x.STATUS ="งดขาย";
              this.statusColor = "Red";
            }

            if (x.OH_QTY == 0) {
              x.STATUS = "ของหมด";
              this.statusColor = "Red";
            } else {
              x.STATUS = "มีของ";
              this.statusColor = "Blue";
            }

          });
        }, (err) => {
          console.log(err, 'err')
          this.modal.warning("Found an error, please contract support team", this.viewref);
        });
    } else {
      this.modal.warning("Please fill part no.", this.viewref);
    }
  }

  public Back() {
    this.showList01 = false;
    this.paramSearch.PART_NO = null;
  }

 

  ngOnInit() {
    this.showList01 = false;
    const show_user: any = [
      this.authService.isAuthenticated() && this.auth.getDetail().ssNameTH,
      this.authService.isAuthenticated() && this.auth.getDetail().ssUserName];
    this.ssNameTH = show_user[0];
    this.ssUserName = show_user[1];
  }
}
