import { Component, OnInit, Input, Output, EventEmitter, TemplateRef, ContentChild, ViewChild, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Router } from '@angular/router';
import { Globals } from 'src/app/core/global';
import { ModalService } from '../../../core/modal.service';
import { AuthDecode } from 'src/app/core/auth-decode.service';
import { AuthService } from 'src/app/core/auth-service.service';
import * as moment from 'moment';

@Component({
  selector: 'SNEN007',
  templateUrl: './SNEN007.component.html',
  styleUrls: ['./SNEN007.component.css']
})


export class SNEN007Component implements OnInit {


  constructor(
    private http: HttpService,
    private router: Router,
    private modal: ModalService,
    private viewref: ViewContainerRef,
    private global: Globals,
    private auth: AuthDecode,
    private authService: AuthService,
  ) { }

  public CustomerList: any = [];
  public param: any = {}
  public paramSearch: any = {};
  public tabledata1: any = [];
  public showList01: Boolean;
  public showList: Boolean;
  public ssNameTH: string;
  public ssUserName: string;

  ngOnInit() {
    this.showList01 = false;
    this.showList = true;
    const show_user: any = [
      this.authService.isAuthenticated() && this.auth.getDetail().ssNameTH,
      this.authService.isAuthenticated() && this.auth.getDetail().ssUserName];
    this.ssNameTH = show_user[0];
    this.ssUserName = show_user[1];
 
  }

  public Search() {
    if (this.paramSearch.PART_NO) {
    this.showList01 = true;
    this.showList = true;
    this.tabledata1 = [];
    this.http.post("PC", "SNEN007_GetData", this.paramSearch)
      .subscribe(res => {
        this.tabledata1 = res.Table;
       
      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contract support team", this.viewref);
      });
    } else {
      this.modal.warning("Please fill part no.", this.viewref);
    }
  }

  public Back() {
    this.showList = true;
    this.showList01 = false;
    this.paramSearch.PART_NO = null;
  }
}

