import { Component, OnInit, Input, Output, EventEmitter, TemplateRef, ContentChild, ViewChild, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Router } from '@angular/router';
import { Globals } from 'src/app/core/global';
import { ModalService } from '../../../core/modal.service';
import { AuthDecode } from 'src/app/core/auth-decode.service';
import { AuthService } from 'src/app/core/auth-service.service';
import * as moment from 'moment';

@Component({
  selector: 'SNEN008',
  templateUrl: './SNEN008.component.html',
  styleUrls: ['./SNEN008.component.css']
})


export class SNEN008Component implements OnInit {


  constructor(
    private http: HttpService,
    private router: Router,
    private modal: ModalService,
    private viewref: ViewContainerRef,
    private global: Globals,
    private auth: AuthDecode,
    private authService: AuthService,
  ) { }

  public CustomerList: any = [];
  public param: any = {}
  public paramSearch: any = {};
  public tableData1: any = [];
  public tablemsalechanel: any = [];
  public showList01: Boolean;
  public FormPNO: Boolean;
  public ListShowPhoto: Boolean;
  public ListPartPhoto: Boolean;
  public showList: Boolean;
  public statusColor: any = {};
  public ssNameTH: string;
  public ssUserName: string;


  public tableListPartPhoto: any = [];
  public tableviewPartPhoto: any = [];

  ngOnInit() {
    this.showList01 = false;
    this.FormPNO = true;
    this.ListPartPhoto = false;
    this.ListShowPhoto = false;
    const show_user: any = [
      this.authService.isAuthenticated() && this.auth.getDetail().ssNameTH,
      this.authService.isAuthenticated() && this.auth.getDetail().ssUserName];
    this.ssNameTH = show_user[0];
    this.ssUserName = show_user[1];
  }

  public Viewphoto() {
    this.showList01 = false;
    this.FormPNO = false;
    this.ListPartPhoto = true;
    this.tableListPartPhoto = [];
    this.http.post("PC", "SNEN008_Get_List_Photo", null)
      .subscribe(res => {
        this.tableListPartPhoto = res.Table;
      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contract support team", this.viewref);
      });
  }

  public ViewPartphoto(data) {
    this.ListShowPhoto = true;
    this.showList01 = false;
    this.FormPNO = false;
    this.ListPartPhoto = false;
    
  }

  //public Listphoto() {
  //  this.tableListPartPhoto = [];
  //  this.http.post("wPMS", "SNEN008_Get_List_Photo", null)
  //    .subscribe(res => {
  //      this.tableListPartPhoto = res.Table;
  //      console.log(this.tableListPartPhoto);
  //    }, (err) => {
  //      console.log(err, 'err')
  //      this.modal.warning("Found an error, please contract support team", this.viewref);
  //    });
  //}

  public Search() {
    if (this.ssUserName == "257200" || this.ssUserName == "590743" || this.ssUserName == "646408"||this.ssUserName == "586791" || this.ssUserName == "572943") {
      if (this.paramSearch.PART_NO) {
        this.showList01 = true;
        this.tableData1 = [];
        this.http.post("PC", "SNEN008_GetData", this.paramSearch)
          .subscribe(res => {
            console.log(res);
            this.tableData1 = res.Table;
            this.tableData1.forEach((x) => {
              if (x.LOCK_SALES == 117) {
                x.STATUS = "สอบถาม";
                this.statusColor = 'Green';
              } else if (x.LOCK_SALES != 0) {
                x.STATUS = "งดขาย";
                this.statusColor = 'Red';
              }
              if (x.TOH_QTY > 0) {
                x.STATUS = "มีของ";
                this.statusColor = 'Black';
              } else {

                x.STATUS = "ของหมด";
                x.GET_ETP_DATE_EO_BKK = x.GET_ETP_DATE_EO_BKK;
                x.GET_ETP_DATE_EO_UPC = x.GET_ETP_DATE_EO_UPC;
                x.GET_ETP_DATE_RO_BKK = x.GET_ETP_DATE_RO_BKK;
                x.GET_ETP_DATE_RO_UPC = x.GET_ETP_DATE_RO_UPC;
                this.statusColor = 'Red';
              }
            });
          }, (err) => {
            console.log(err, 'err')
            this.modal.warning("Found an error, please contract support team", this.viewref);
          });
      } else {
        this.modal.warning("Please fill part no.", this.viewref);
      }
    } else {
      if (this.paramSearch.PART_NO) {
        this.showList01 = true;
        this.tableData1 = [];
        this.http.post("PC", "SNEN008_GetData", this.paramSearch)
          .subscribe(res => {
            console.log(res);
            this.tableData1 = res.Table1;
            this.tableData1.forEach((x) => {
              if (x.LOCK_SALES == 117) {
                x.STATUS = "สอบถาม";
                this.statusColor = 'Green';
              } else if (x.LOCK_SALES != 0) {
                x = "งดขาย";
                this.statusColor = 'Red';
              }
              if (x.TOH_QTY > 0) {
                x.STATUS = "มีของ";
                this.statusColor = 'Black';
              } else {
                x.STATUS = "ของหมด";
                x.GET_ETP_DATE_EO_BKK = x.GET_ETP_DATE_EO_BKK;
                x.GET_ETP_DATE_EO_UPC = x.GET_ETP_DATE_EO_UPC;
                x.GET_ETP_DATE_RO_BKK = x.GET_ETP_DATE_RO_BKK;
                x.GET_ETP_DATE_RO_UPC = x.GET_ETP_DATE_RO_UPC;
                this.statusColor = 'Red';
              }
            });
          }, (err) => {
            console.log(err, 'err')
            this.modal.warning("Found an error, please contract support team", this.viewref);
          });
      } else {
        this.modal.warning("Please fill part no.", this.viewref);
      }
    }
   
  }

  

  public Back() {
    this.showList01 = false;
    this.FormPNO = true;
    this.paramSearch.PART_NO = null;
  }

  public BackListPartPhoto() {
    this.showList01 = false;
    this.FormPNO = false;
    this.ListPartPhoto = true;
    this.ListShowPhoto = false;
  }

  public BackToSearch() {
    this.showList01 = false;
    this.FormPNO = true;
    this.ListPartPhoto = false;
    this.ListShowPhoto = false;
  }
  
}
