import { Component, OnInit, Input, Output, EventEmitter, TemplateRef, ContentChild, ViewChild, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Router } from '@angular/router';
import { Globals } from 'src/app/core/global';
import { ModalService } from '../../../core/modal.service';
import { AuthDecode } from 'src/app/core/auth-decode.service';
import { AuthService } from 'src/app/core/auth-service.service';
import * as moment from 'moment';
import { DialogTemplateComponent } from 'src/app/components/shared/dialog-template/dialog-template.component';


@Component({
  selector: 'SNEN010',
  templateUrl: './SNEN010.component.html',
  styleUrls: ['./SNEN010.component.css']
})


export class SNEN010Component implements OnInit {


  constructor(
    private http: HttpService,
    private router: Router,
    private modal: ModalService,
    private viewref: ViewContainerRef,
    private auth: AuthDecode,
    private authService: AuthService,
    private global: Globals
  ) { }

  public CustomerList: any = [];
  public param: any = {};
  public showList: Boolean;
  public List01: Boolean;
  public List02: Boolean;
  public List03: Boolean;
  public tableDealerStock: any = [];
  public tableData01: any = [];
  public tableData02: any = [];
  public tableData03: any = [];
  public statusColor: any = {};
  public ssNameTH: string;
  public ssUserName: string;
  public paramZone: any = {};
  public formdata: any = {};

  ngOnInit() {
    this.showList = true;
    this.List01 = false;
    this.List02 = false;
    this.List03 = false;
    const show_user: any = [
      this.authService.isAuthenticated() && this.auth.getDetail().ssNameTH,
      this.authService.isAuthenticated() && this.auth.getDetail().ssUserName];
    this.ssNameTH = show_user[0];
    this.ssUserName = show_user[1];
    this.search();
  }

  public search() {
    this.tableDealerStock = [];
    this.http.post("PC", "SNEN010_GetData", this.search)
      .subscribe(res => {
        this.tableDealerStock = res.Table;
        console.log(res.Table)
      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contract support team", this.viewref);
      });
  }

  public ViewData(data) {
    this.showList = false;
    this.List01 = true;
    this.List02 = false;
    this.List03 = false;
    this.tableData01 = [];
    this.param.ZONE_NAME = data.ZONE_NAME;
    const param = {
      ZONE_CODE: data.ZONE_CODE,
      ZONE_NAME: data.ZONE_NAME
    };
    this.http.post("PC", "SNEN010_GetData_Dealer", param)
      .subscribe(res => {
        this.tableData01 = res.Table;
      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contract support team", this.viewref);
      });

  }
  public ViewDealerStock(data) {
    this.showList = false;
    this.List01 = false;
    this.List02 = true;
    this.List03 = false;
    this.tableData02 = [];
    this.param.DEALER_CODE = data.DEALER_CODE;
    this.param.DEALER_NAME = data.DEALER_NAME;
    this.param.EFFECTIVE_DATE = data.EFFECTIVE_DATE;
    const param = {
      DEALER_CODE: data.DEALER_CODE
    };
    this.http.post("PC", "SNEN010_GetData_Pmc", param)
      .subscribe(res => {
        this.tableData02 = res.Table;
        //this.tableData02.forEach((item) => {
        // this.ON_HAND
        //}
       
      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contract support team", this.viewref);
      });

  } 

  public ViewDeadStock(data) {
    this.showList = false;
    this.List01 = false;
    this.List02 = false;
    this.List03 = true;
    this.tableData03 = [];
    const param = {
      DEALER_CODE: data.DEALER_CODE,
      PMC_CODE: data.PMC_CODE
    };
    this.http.post("PC", "SNEN010_GetData_By_Dead", param)
      .subscribe(res => {
        this.tableData03 = res.Table;

      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contract support team", this.viewref);
      });

  }
  //button view Details sum data 
  public Details() {
    this.showList = false;
    this.List01 = false;
    this.List02 = false;
    this.List03 = true;
    this.tableData03 = [];
    const param = {
      DEALER_CODE: this.tableData02[0].DEALER_CODE,
      PMC_CODE: this.tableData02[0].PMC_CODE = ""
    };
    this.http.post("PC", "SNEN010_GetData_By_Dead", param)
      .subscribe(res => {
        this.tableData03 = res.Table;
      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contract support team", this.viewref);
      });

  }

  public GetClassValue(retail_price: number) {
    if (retail_price >= 0) {
      return 'Green';
    } else {
      return ''
    }

  }

  public Statuscolor(percent_disc: number) {
    if (percent_disc >= 0) {
      return 'Red';
    } else {
      return ''
    }
  }

  public Textscolor(SALES_PRICE: number) {
    if (SALES_PRICE >= 0) {
      return 'Black';
    } else {
      return ''
    }
  }


  public BackToList() {
    this.showList = true;
    this.List01 = false;
    this.List02 = false;
    this.List03 = false;

  }

  public BackToTable01() {
    this.showList = false;
    this.List01 = true;
    this.List02 = false;
    this.List03 = false;

  }
  public BackToTable02() {
    this.showList = false;
    this.List01 = false;
    this.List02 = true;
    this.List03 = false;
  }

  public summaryTotal: any = [
    {
      fieldName: "ZONE_NAME",
      value: "Sum",
      show: true

    },
    {
      fieldName: "ON_HAND",
      show: true
    },
    {
      fieldName: "SALES_VALUE",
      show: true
    },
    {
      fieldName: "COUNTER",
      show: true

    }

  ]
  public summaryTotalDealer: any[] = [
    {
      fieldName: 'DEALER_NAME',
      value: 'Sum',
      show: true,
    },
    {
      fieldName: 'ON_HAND',
      show: true,
    },
    {
      fieldName: 'SALES_VALUE',
      show: true,
    },
    {
      fieldName: 'COUNTER',
      show: true,
    }

  ]

  public summaryDealerStock: any[] = [
    {
      fieldName: 'PMC_CODE',
      value: 'Sum',
      show: true,

    },
    {
      fieldName: 'ON_HAND',
      show: true,
    },
    {
      fieldName: 'SALES_VALUE',
      show: true,
    },
    {
      fieldName: 'COUNTER',
      show: true,
    }
  ]

  public SummaryDeadstock: any[] = [
    {
      fieldName: 'PMC_CODE',
      value: 'Sum',
      show: true,

    },
    {
      fieldName: 'ON_HAND',
      show: true,
    }
  ]
}
