import { Component, OnInit, Input, Output, EventEmitter, TemplateRef, ContentChild, ViewChild, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Router } from '@angular/router';
import { Globals } from 'src/app/core/global';
import { ModalService } from '../../../core/modal.service';
import * as moment from 'moment';
import { AuthDecode } from 'src/app/core/auth-decode.service';
import { AuthService } from 'src/app/core/auth-service.service';
import { environment } from './../../../../environments/environment';

@Component({
  selector: 'SNEN022',
  templateUrl: './SNEN022.component.html',
  styleUrls: ['./SNEN022.component.css']
})


export class SNEN022Component implements OnInit {
  public userName: string;
  public userCode: string;
  public userID: string;


  constructor(
    private http: HttpService,
    private router: Router,
    private modal: ModalService,
    private viewref: ViewContainerRef,
    private global: Globals,
    private auth: AuthDecode,
    private authService: AuthService
  ) { }

  public vendor: any = { VENDOR_CODE: "", VENDOR_NAME: "" };
  public param: any = {}
  public paramSearch: any = {}
  public paramHead: any = {}
  public paramDate: any = {}
  public tableData: any = [];
  public tableCheck: any = [];
  public tableVender: any = [];

  ngOnInit(): void {
    this.userName = this.authService.isAuthenticated() && this.auth.getDetail().ssNameTH;
    this.userCode = this.authService.isAuthenticated() && this.auth.getDetail().ssUserName;
    var DatetimeString = new Date();
    var momentVariable = moment(DatetimeString, 'MM-DD-YYYY');
    this.paramDate = momentVariable.format('DD/MM/YYYY HH:MM:SS');
    this.Search();
  }

  public Search() {
    this.tableCheck = [];
    this.tableVender = [];
    this.tableData = [];
    this.http.post("PC", "SNEN022_GetData_Vendor_Code", this.param)
      .subscribe(
        (res) => {
         // console.log('res ', res);
          this.tableCheck = res.Table;
          this.paramHead.HEAD_VENDOR_CODE = this.tableCheck[0].VENDOR_CODE;

          const param = {
            VENDOR_CODE: this.tableCheck[0].VENDOR_CODE
          };
         // console.log('param > ', param);
          this.http.post('PC', 'SNEN022_GetData_Vendor_Name', param)
            .subscribe(
              (res) => {
                this.tableVender = res.Table;
                this.paramHead.HEAD_VENDOR_NAME = this.tableVender[0].VENDOR_NAME;
              },
              (err) => {
                this.modal.warning("Found an error, please contract support team", this.viewref);
              }
          );

          const paramSearch = {
            VENDOR_CODE: this.tableCheck[0].VENDOR_CODE
          };
         // console.log('paramSearch > ', paramSearch);
          this.http.post('PC', 'SNEN022_GetData', paramSearch)
            .subscribe(
              (res) => {
                // console.log(res);
                this.tableData = res.Table;
              },
              (err) => {
                this.modal.warning("Found an error, please contract support team", this.viewref);
              }
            );
          
        },
        (err) => {
          this.modal.warning("Found an error, please contract support team", this.viewref);
        }
    );


  }

  public GetClassValue(diff_day: number) {
   /* console.log('diff_day >>', diff_day)*/
    if (diff_day <= 5) {
      return 'Red';
      } else if (diff_day > 5 && diff_day <= 10) {
        return 'Green';
    } else {
      return ''
    }
  }

}
  



