import { Component, OnInit, Input, Output, EventEmitter, TemplateRef, ContentChild, ViewChild, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Router } from '@angular/router';
import { Globals } from 'src/app/core/global';
import { ModalService } from '../../../core/modal.service';
import * as moment from 'moment';
import { AuthDecode } from 'src/app/core/auth-decode.service';
import { AuthService } from 'src/app/core/auth-service.service';


@Component({
  selector: 'SNEN024',
  templateUrl: './SNEN024.component.html',
  styleUrls: ['./SNEN024.component.css']
})


export class SNEN024Component implements OnInit {
  public userName: string;
  public userCode: string;

  constructor(
    private http: HttpService,
    private router: Router,
    private modal: ModalService,
    private viewref: ViewContainerRef,
    private global: Globals,
    private auth: AuthDecode,
    private authService: AuthService
  ) { }

  public CustomerList: any = [];
  public paramSearch: any = {};
  // public param: any = {}
  public showTab: Boolean;
  public showDetail: Boolean;
  public tabledata: any = [];
  public tabledata2: any = [];
  public tabledata3: any = [];
  public tabledata4: any = [];
  public listTrans: any = [];
 
  // public data: any = {};
  public paramsHead: any = {};

  ngOnInit(): void {
    this.showTab = true;
    this.showDetail = false;
    this.userName = this.authService.isAuthenticated() && this.auth.getDetail().ssNameTH;
    this.userCode = this.authService.isAuthenticated() && this.auth.getDetail().ssUserName;
    //var dateString = new Date();
    //var momentVariable = moment(dateString, 'MM-DD-YYYY');
    //this.paramSearch.YEAR_MONTH = momentVariable.format('MM/YYYY');
    this.paramSearch.INVOICE_NO = '';
  }

  public Search() {
    this.tabledata = [];
    this.tabledata2 = [];
    this.tabledata3 = [];
    this.tabledata4 = [];
    if (!this.paramSearch.INVOICE_NO) {
      this.showTab = true;
      this.modal.info("กรุณากรอกเลขที่เอกสาร", this.viewref, () => {
      });
    
    } else if (this.paramSearch.INVOICE_NO) {
      this.showTab = false;
      this.http.post("PC", "SNEN024_GetData", this.paramSearch)
        .subscribe(res => {
          this.tabledata = res.Table
          if (this.tabledata.length > 0) {
            this.paramsHead.TOTAL_NET_B = this.tabledata[0].TOTAL_NET_B;
            this.paramsHead.TOTAL_VAT = this.tabledata[0].TOTAL_VAT;
            this.paramsHead.TOTAL_RETAIL_B = this.tabledata[0].TOTAL_RETAIL_B;
            this.paramsHead.ROUTE_CODE = this.tabledata[0].ROUTE_CODE;
            this.paramsHead.TOTAL_DISCOUNT = this.tabledata[0].TOTAL_DISCOUNT;
            this.paramsHead.CUSTOMER_CODE = this.tabledata[0].CUSTOMER_CODE;
            this.paramsHead.BRANCH_CODE = this.tabledata[0].BRANCH_CODE;
            this.paramsHead.DOCUMENT_NO = this.tabledata[0].DOCUMENT_NO;
            this.paramsHead.PAYMENT_TERM = this.tabledata[0].PAYMENT_TERM;
            this.paramsHead.DOCUMENT_DATE = this.tabledata[0].DOCUMENT_DATE;


            const param = {
              CUSTOMER_CODE: this.tabledata[0].CUSTOMER_CODE,
              INVOICE_NO: this.tabledata[0].DOCUMENT_NO,
              BRANCH_CODE: this.tabledata[0].BRANCH_CODE
            };
            this.http.post('PC', 'SNEN024_GetData_Detail', param).subscribe((res) => {

              this.tabledata2 = res.Table;
              if (this.tabledata2.length > 0) {
                this.paramsHead.CUST_NAME_TH = this.tabledata2[0].CUST_NAME_TH;
                this.paramsHead.CUST_ADDR = this.tabledata2[0].CUST_ADDR;
              }
              this.tabledata3 = res.Table1;

              if (this.tabledata3.length > 0) {
                this.paramsHead.DOC_NAME_EN = this.tabledata3[0].DOC_NAME_EN;

              }
              this.tabledata4 = res.Table2;
              if (this.tabledata4.length > 0) {
                this.paramsHead.BRANCH_NAME_TH = this.tabledata4[0].BRANCH_NAME_TH;
              }
            });

            if (this.tabledata[0].DELIVERY_CODE != '') {
              if (this.tabledata[0].DELIVERY_CODE == '01') {
                this.paramsHead.DELIVERY_CODE = "รอรับทันที";
              } else if (this.tabledata[0].DELIVERY_CODE == '02') {
                this.paramsHead.DELIVERY_CODE = "รอรับ";
              } else if (this.tabledata[0].DELIVERY_CODE == '03') {

                this.listTrans = [];
                const param = {
                  TRANSPORT_CODE: this.tabledata[0].TRANSPORT_CODE
                };
                this.http.post('PC', 'SNEN024_GetData_Transport', param).subscribe((res) => {
                  this.listTrans = res.Table;
                  if (this.listTrans.length > 0) {
                    if (this.listTrans[0].TRANS_NAME_EN != '') {
                      this.paramsHead.TRANSPORT_NAME = this.tabledata[0].DELIVERY_CODE + "-" + this.listTrans[0].TRANS_NAME_EN + " " + " จัดส่ง ";
                    } else {
                      this.paramsHead.TRANSPORT_NAME = this.tabledata[0].DELIVERY_CODE + " " + " จัดส่ง ";
                    }
                  }
                });
              }
            }
            this.showDetail = true;
            this.showTab = false;
          } else {
            this.showDetail = false;
            this.showTab = true;
          }

          

        }, (err) => {
          console.log(err, 'err')
          this.modal.warning("Found an error, please contract support team", this.viewref);
        });
    }

  }

  public back() {
    this.showTab = true;
    this.showDetail = false;
  }

  public TOTAL_QTR() {
    var total_qty = 0;
    this.tabledata.forEach((d) => {
      total_qty += d.ITEM_QTY;
    })
    return total_qty;
  }

}
