import { Component, OnInit, Input, Output, EventEmitter, TemplateRef, ContentChild, ViewChild, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Router } from '@angular/router';
import { Globals } from 'src/app/core/global';
import { ModalService } from '../../../core/modal.service';
import { AuthDecode } from 'src/app/core/auth-decode.service';
import { AuthService } from 'src/app/core/auth-service.service';
import * as moment from 'moment';
import { DialogTemplateComponent } from 'src/app/components/shared/dialog-template/dialog-template.component';

@Component({
  selector: 'SNEN026',
  templateUrl: './SNEN026.component.html',
  styleUrls: ['./SNEN026.component.css']
})


export class SNEN026Component implements OnInit {


  constructor(
    private http: HttpService,
    private router: Router,
    private modal: ModalService,
    private viewref: ViewContainerRef,
    private global: Globals,
    private auth: AuthDecode,
    private authService: AuthService,
  ) { }

  public CustomerList: any = [];
  public param: any = {}
  public paramsHead: any = {}
  public showList: Boolean;
  public showList01: Boolean;
  public showDetail: Boolean;
  public paramSearch: any = {};
  public formData: any = {};
  public dataDate: any = [];
  public ssNameTH: string;
  public ssUserName: string;
  public dataTable: any = [];
  public tabledata_1: any = [];
  public tabledata_2: any = [];
  public tabledata_3: any = [];
  public tabledata_4: any = [];
  public listTrans: any = [];

  ngOnInit(){
    this.showList = true;
    this.showList01 = false;
    this.Search();
    const show_user: any = [
      this.authService.isAuthenticated() && this.auth.getDetail().ssNameTH,
      this.authService.isAuthenticated() && this.auth.getDetail().ssUserName];
    this.ssNameTH = show_user[0];
    this.ssUserName = show_user[1];
    var dateString = new Date();
    var momentVariable = moment(dateString, 'MM-DD-YYYY');
    this.paramSearch.YEAR_MONTH = momentVariable.format('MM/YYYY');
  }

  

  public ViewData(data){
    this.showList01 = true;
    this.showList = false;
    this.formData = data;
   // console.log('---', data);
  }

  public Search() {
    this.showList = true;
    this.dataTable = [];

    this.http.get("PC", "SNEN026_GetData")
      .subscribe(result => {
        this.dataTable = result;
      })
  }

  public SearchInvoice() {
    this.showList = false;
    this.showList01 = true;
    this.dataDate = [];
    const param = {
      YEAR_MONTH: this.paramSearch.YEAR_MONTH,
      CUSTOMER_CODE: this.formData.CUSTOMER_CODE
    };
  // console.log(param);
    this.http.post("PC", "SNEN026_GetData_By_Date",param)
      .subscribe(res => {
       // console.log('----',res);
        this.dataDate = res.Table;
       // let dataTableDate = this.dataDate;
        if (this.dataDate.length > 0) {
          // tempData = JSON.parse(JSON.stringify(res.Table))
          let temp_date = this.dataDate[0].INVOICE_DATE;
          let temp_invoicedate = this.dataDate[0].INVOICE_DATE;
          let total_amt = 0;
          let total_qty = 0;
          let item_no = 1;
         
          this.dataDate.forEach((x, i) => {
            x.SUM = 0
            //x.ITEM = null
           // console.log('', temp_date.format('DD/MM/YYYY'), '--', x.INVOICE_DATE.format('DD/MM/YYYY'));
            if (temp_date != x.INVOICE_DATE ) {
              item_no += 1;
              x.ITEM = item_no

             // console.log('x.ITEM ? ', x.ITEM);

              let obj = {
                ITEM: null,
                SUM: total_amt,
                INVOICE_DATE: null,
                INVOICE_NO: "Total",
                TOTAL_AMOUNT: total_amt,
                TOTAL_QTY: total_qty
              }

              this.dataDate.splice(i, 0, obj);
              this.dataDate.slice(i, 0, obj);   // หาผล Sum

              temp_date = x.INVOICE_DATE
              total_amt = x.TOTAL_AMOUNT
              total_qty = x.TOTAL_QTY

            }
            else {

              total_amt += x.TOTAL_AMOUNT
              total_qty += x.TOTAL_QTY

              //x.ITEM = null
              if (!x.ITEM) {
                x.INVOICE_DATE = null
              }
            }
          });

          this.dataDate[0].ITEM = 1;
          this.dataDate[0].INVOICE_DATE = temp_invoicedate;

        }

      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contract support team", this.viewref);
      });

  }


  public ViewDetail(data) {
    this.showList = false;
    this.showList01 = false;
    this.showDetail = true;
    this.tabledata_1 = [];
    this.tabledata_2 = [];
    this.tabledata_3 = [];
    this.tabledata_4 = [];
   // console.log('data >> ', data);
    this.http.post("PC", "SNEN026_GetData_Detail", data)
      .subscribe(res => {
    //  console.log('>>>', res);
        this.tabledata_1 = res.Table;
        this.paramsHead.TOTAL_NET_B = this.tabledata_1[0].TOTAL_NET_B;
        this.paramsHead.TOTAL_VAT = this.tabledata_1[0].TOTAL_VAT;
        this.paramsHead.TOTAL_RETAIL_B = this.tabledata_1[0].TOTAL_RETAIL_B;
        this.paramsHead.ROUTE_CODE = this.tabledata_1[0].ROUTE_CODE;
        this.paramsHead.TOTAL_DISCOUNT = this.tabledata_1[0].TOTAL_DISCOUNT;
        this.paramsHead.CUSTOMER_CODE = this.tabledata_1[0].CUSTOMER_CODE;
        this.paramsHead.BRANCH_CODE = this.tabledata_1[0].BRANCH_CODE;
        this.paramsHead.DOCUMENT_NO = this.tabledata_1[0].DOCUMENT_NO;
        this.paramsHead.PAYMENT_TERM = this.tabledata_1[0].PAYMENT_TERM;
        this.paramsHead.DOCUMENT_DATE = this.tabledata_1[0].DOCUMENT_DATE;
        this.tabledata_2 = res.Table1;
        this.paramsHead.CUST_NAME_TH = this.tabledata_2[0].CUST_NAME_TH;
        this.paramsHead.CUST_ADDR = this.tabledata_2[0].CUST_ADDR;
        this.tabledata_3 = res.Table2;
        this.paramsHead.DOC_NAME_EN = this.tabledata_3[0].DOC_NAME_EN;
        this.tabledata_4 = res.Table3;
        this.paramsHead.BRANCH_NAME_TH = this.tabledata_4[0].BRANCH_NAME_TH;
        // if (this.tabledata_1.length > 0) {

        if (this.tabledata_1[0].DELIVERY_CODE != '') {
          if (this.tabledata_1[0].DELIVERY_CODE == '01') {
            this.paramsHead.DELIVERY_CODE = "รอรับทันที";
          } else if (this.tabledata_1[0].DELIVERY_CODE == '02') {
            this.paramsHead.DELIVERY_CODE = "รอรับ";
          } else if (this.tabledata_1[0].DELIVERY_CODE == '03') {

            this.listTrans = [];
            const param = {
              TRANSPORT_CODE: this.tabledata_1[0].TRANSPORT_CODE
            };
            this.http.post('PC', 'SNEN026_GetData_Transport', param).subscribe((res) => {
              this.listTrans = res.Table;
              if (this.listTrans.length > 0) {
                this.paramsHead.DELIVERY_CODE = this.tabledata_1[0].DELIVERY_CODE + "-" + this.listTrans[0].TRANS_NAME_EN + " " + " จัดส่ง ";
              } else {
                this.paramsHead.DELIVERY_CODE = "-";
              }
            });
          }
        }

      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contract support team", this.viewref);
      });

  }

  public GoToList() {
    this.showList01 = true;
    this.showDetail = false;
  }

  public Back() {
    this.showList = true;
    this.showList01 = false;
    this.showDetail = false;
  }


  public TOTAL_QTR() {
    var total_qty = 0;
    this.tabledata_1.forEach((d) => {
      total_qty += d.ITEM_QTY;
    })
    return total_qty;
  }
}
