import { Component, OnInit, Input, Output, EventEmitter, TemplateRef, ContentChild, ViewChild, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Router } from '@angular/router';
import { Globals } from 'src/app/core/global';
import { ModalService } from '../../../core/modal.service';
import * as moment from 'moment';
import { AuthDecode } from 'src/app/core/auth-decode.service';
import { AuthService } from 'src/app/core/auth-service.service';
import { environment } from './../../../../environments/environment';

@Component({
  selector: 'SNEN030',
  templateUrl: './SNEN030.component.html',
  styleUrls: ['./SNEN030.component.css']
})


export class SNEN030Component implements OnInit {
  public userName: string;
  public userCode: string;
  public userID: string;

  constructor(
    private http: HttpService,
    private router: Router,
    private modal: ModalService,
    private viewref: ViewContainerRef,
    private global: Globals,
    private auth: AuthDecode,
    private authService: AuthService
  ) { }

  public CustomerList: any = [];
  public tableData: any = [];
  public tableData1: any = [];
  public tableData2: any = [];
  public param: any = {}
  public paramSearch: any = {};
  public paramsHead: any = {};
  public paramDate: any = {};
  public showList: Boolean;
  public showDetail: Boolean;


  public summaryTotal: any[] = [
    {
      fieldName: 'CUST_NAME_TH',
      value: 'Grand Total',
      show: true,
    },
    {
      fieldName: 'BO_QTY',
      show: true,
    },
    {
      fieldName: 'BO_AMT',
      show: true,
    },
    {
      fieldName: 'BO_ITEM',
      show: true,
    },
  ];

  public summaryTotal_1: any[] = [
    {
      fieldName: 'PART_NAME_TH',
      value: 'Grand Total',
      show: true,
    },
    {
      fieldName: 'BO_QTY',
      show: true,
    },
    {
      fieldName: 'BO_AMT',
      show: true,
    },
    {
      fieldName: 'BO_ITEM',
      show: true,
    },
  ];


  public summaryTotal_2: any[] = [
    {
      fieldName: 'BOD',
      value: 'Grand Total',
      show: true,
    },
    {
      fieldName: 'BO_QTY',
      show: true,
    },
    {
      fieldName: 'BO_AMT',
      show: true,
    },
    {
      fieldName: 'BO_ITEM',
      show: true,
    },
  ];

  ngOnInit(): void {
    this.showList = true;
    this.userName = this.authService.isAuthenticated() && this.auth.getDetail().ssNameTH;
    this.userCode = this.authService.isAuthenticated() && this.auth.getDetail().ssUserName;
    var DatetimeString = new Date();
    var momentVariable = moment(DatetimeString, 'MM-DD-YYYY');
    this.paramDate = momentVariable.format('DD/MM/YYYY HH:MM:SS');
    this.paramSearch.CUSTOMER_CODE = '';
    this.Search();
  }

  public ViewDetail(num, data) {
    this.showList = false;
    this.showDetail = true;   
    this.tableData1 = [];
    this.tableData2 = [];
    this.paramSearch = { TYPE: '1' };
    var dateString = new Date();
    var momentVariable = moment(dateString, 'MM-DD-YYYY');
    var date = momentVariable.format('DD-MMM-YYYY');
    const param = {
      CUSTOMER_CODE: data.CUST_CODE
    };
    console.log('this.paramSearch', this.paramSearch);
   // if (this.paramSearch.TYPE == 1) {
      this.http.post("PC", "SNEN030_GetData_BODate", param)
        .subscribe(res => {
          this.tableData1 = res.Table;
          this.tableData1 = this.tableData1.slice();   // หาผล Sum
          if (this.tableData1.length > 0) {

            this.paramSearch.CUST_CODE = this.tableData1[0].CUSTOMER_CODE;
            this.paramSearch.CUST_NAME = this.tableData1[0].CUSTOMER_NAME;
            this.paramSearch.BRANCH_NAME = this.tableData1[0].BRANCH_NAME;

            let temp_date = this.tableData1[0].BOD;
            let temp_invoicedate = this.tableData1[0].BOD;
            let total_amt = 0;
            let total_qty = 0;
            let item_no = 1;
 
            this.tableData1.forEach((x,i) => {             
              if (temp_date != x.BOD) {
                item_no += 1;
                x.ITEM = item_no
                let obj = {
                  ITEM: null,
                  BOD: null,
                }
                this.tableData1.slice(i, 0, obj);   // หาผล Sum
                temp_date = x.BOD
              } else {

                if (!x.ITEM) {
                  x.BOD = null
                }
              }

              if (x.SALES_CHANNEL == 20 || x.SALES_CHANNEL == 40) {
                if (x.ORDER_CLASS == 1 || x.ORDER_CLASS == 2 || x.ORDER_CLASS == 5 || x.ORDER_CLASS == 7) {
                  x.ETA_DATE = x.ETA_EO_UPC_DATE
                } else {
                  x.ETA_DATE = x.ETA_RO_UPC_DATE
                }
              } else {
                if (x.ORDER_CLASS == 1 || x.ORDER_CLASS == 2 || x.ORDER_CLASS == 5 || x.ORDER_CLASS == 7) {
                  x.ETA_DATE = x.ETA_EO_BKK_DATE
                } else {
                  x.ETA_DATE = x.ETA_RO_BKK_DATE
                }
              }

              if (x.ETA_DATE == '-') {
                x.ETA_DATE = x.GET_ETA_DATE

              }

              if (x.ETA_DATE) {
                if (x.ETA_DATE < date || x.HIDE_ETA_FLAG == 'Y') {
                  this.paramsHead.TYPE = 1;
                  x.ETA_DATE = 'สอบถาม';
                }
              }

              if (x.HIDE_ETA_FLAG == 'Y') {
                this.paramsHead.TYPE = 1;
                x.ETA_DATE = 'สอบถาม';
              }

             
            });

            this.tableData1[0].ITEM = 1;
            this.tableData1[0].BOD = temp_invoicedate;
            
          }
        }, (err) => {
          console.log(err, 'err')
          this.modal.warning("Found an error, please contract support team", this.viewref);
        });
 // } else {
    //  console.log('param >> ', param);
      this.http.post("PC", "SNEN030_GetData_PartsNo", param)
        .subscribe(res => {
          this.tableData2 = res.Table;
          this.tableData2 = this.tableData2.slice();   // หาผล Sum
          if (this.tableData2.length > 0) {
            this.paramSearch.CUST_CODE = this.tableData2[0].CUSTOMER_CODE;
            this.paramSearch.CUST_NAME = this.tableData2[0].CUSTOMER_NAME;
            this.paramSearch.BRANCH_NAME = this.tableData2[0].BRANCH_NAME;

            let temp_partno = this.tableData2[0].PART_NO;
            let temp_partno2 = this.tableData2[0].PART_NO;
            let temp_partname = this.tableData2[0].PART_NAME_TH;
            let total_amt = 0;
            let total_qty = 0;
            let item_no = 1;

            this.tableData2.forEach((x,i) => {


              if (temp_partno != x.PART_NO) {
                item_no += 1;
                x.ITEM = item_no
                let obj = {
                  ITEM: null,
                  PART_NO: null,
                  PART_NAME_TH: null,
                }
                this.tableData2.slice(i, 0, obj);   // หาผล Sum
                temp_partno = x.PART_NO
              } else {

                if (!x.ITEM) {
                  x.PART_NO = null
                  x.PART_NAME_TH = null
                }
              }

              if (x.SALES_CHANNEL == 20 || x.SALES_CHANNEL == 40) {
                if (x.ORDER_CLASS == 1 || x.ORDER_CLASS == 2 || x.ORDER_CLASS == 5 || x.ORDER_CLASS == 7) {
                  x.ETA_DATE = x.ETA_EO_UPC_DATE
                } else {
                  x.ETA_DATE = x.ETA_RO_UPC_DATE
                }
              } else {
                if (x.ORDER_CLASS == 1 || x.ORDER_CLASS == 2 || x.ORDER_CLASS == 5 || x.ORDER_CLASS == 7) {
                  x.ETA_DATE = x.ETA_EO_BKK_DATE
                } else {
                  x.ETA_DATE = x.ETA_RO_BKK_DATE
                }
              }

              if (x.ETA_DATE == '-') {
                x.ETA_DATE = x.GET_ETA_DATE

              }

              if (x.ETA_DATE) {
                if (x.ETA_DATE < date || x.HIDE_ETA_FLAG == 'Y') {
                  this.paramsHead.TYPE = 1;
                  x.ETA_DATE = 'สอบถาม';
                }
              }

              if (x.HIDE_ETA_FLAG == 'Y') {
                this.paramsHead.TYPE = 1;
                x.ETA_DATE = 'สอบถาม';
              }


            });
            this.tableData2[0].ITEM = 1;
            this.tableData2[0].PART_NO = temp_partno2;
            this.tableData2[0].PART_NAME_TH = temp_partname;

          }
        }, (err) => {
          console.log(err, 'err')
          this.modal.warning("Found an error, please contract support team", this.viewref);
        });
  // }
  }


  public Search() {
    this.tableData = [];
    const param = {
      CUSTOMER_CODE: this.paramSearch.CUSTOMER_CODE
    };
    //  console.log('param >> ', param)
    this.http.post("PC", "SNEN030_GetData", param)
      .subscribe(res => {
        //console.log('res >> ', res)
        this.tableData = res.Table;
        if (this.tableData.length > 0) {
          //this.paramSearch.CUST_CODE = this.tableData[0].CUST_CODE
        }
      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contract support team", this.viewref);
      });
  }




  public EditRow(data) {
    this.showList = false;
    this.showDetail = true;
    this.tableData1 = [];
    this.paramSearch.CUST_CODE = data.CUST_CODE;
    const param = {
      CUSTOMER_CODE: data.CUST_CODE,
    };
    //  console.log('param >> ', param)
    this.http.post("PC", "SNEN030_GetData_BODate", param)
      .subscribe(res => {
        //console.log('res >> ', res)
        this.tableData1 = res.Table;
        if (this.tableData1.length > 0) {

        }
      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contract support team", this.viewref);
      });
  }

  public GoToList() {
    this.Search();
    this.showList = true;
    this.showDetail = false;
  }

  
}
