import { Component, OnInit, Input, Output, EventEmitter, TemplateRef, ContentChild, ViewChild, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Router } from '@angular/router';
import { Globals } from 'src/app/core/global';
import { ModalService } from '../../../core/modal.service';
import { AuthDecode } from 'src/app/core/auth-decode.service';
import { AuthService } from 'src/app/core/auth-service.service';
import { NgForm } from '@angular/forms';
import * as moment from 'moment';
import { yearsPerPage } from '@angular/material/datepicker';
import { RIGHT_ARROW } from '@angular/cdk/keycodes';
import { exists } from 'fs';


enum PageAction {
  Search = 0,
  Detail,
  Retrive
}


@Component({
  selector: 'SNEN050',
  templateUrl: './SNEN050.component.html',
  styleUrls: ['./SNEN050.component.css']
})


export class SNEN050Component implements OnInit {
  constructor(
    private http: HttpService,
    private router: Router,
    private modal: ModalService,
    private viewref: ViewContainerRef,
    private global: Globals,
    private auth: AuthDecode,
    private authService: AuthService,
  ) { }
  public tablespname: any = [];
  public tablelistsupplieradd: any = [];
  public tableionumber: any = [];
  public tablebudgetcode: any = [];
  public tablelistitem: any = [];
  public tablelistsubnameitem: any = [];
  public tableexpensecode: any = [];
  public tableliswhtax: any = [];
  public tablelistdepartment: any = [];
  public tablelistcur: any = [];
  public formData: any = {};
  public param: any = {}
  public params: any = {}
  public paramsSearch: any = {}
  public paramDetail: any = {}
  public addSubitemdetails: Boolean;
  public ShowList: Boolean;
  public List02: Boolean;
  public List03: Boolean;
  public List04: Boolean;
  public claimformprint: Boolean;
  public showheader: Boolean;
  public vocuherlist: Boolean;
  public tableDatavocuher: any = [];
  public monthArr: any = [];
  public tableaddaccrue: any = [];
  public monthexport: any = [];
  public paramSearch: any = {}
  public supplier: any = {}
  public ParamsAdd: any = {}
  public PageAction: number;
  public ssNameTH: string;
  public userName: string;
  public userCode: string;
  public detail_add: any={};
  public filter: any = {};
  public ParamsAddDetail: any ={};
  public property: any = ["SUPPLIER_INVOICE_NO","ITEM_ID","NISSAN_INVOICE_NO","DEPARTMENT","IO_NUMBER","CUR","TOTAL_AMOUNT_OF_INVOICE","RATE","EXPENSE_AMOUNT","INPUT_VAT_AMOUNT","WH_TAX_AMOUNT"];
 
  ngOnInit() {
    this.showheader = true;
    this.ShowList = false;
    this.addSubitemdetails = false;
    this.List02 = false;
    this.List03 = false;
    this.List04 = false;
    this.vocuherlist = false;
    this.claimformprint = false;
    this.params.Supplier_Name = "";
    //this.ViewData();
    //this.Selectaddsupplier();
    this.selectbudgetcode();
    this.selectexpensecode();
    this.create_monthly_Purpose();
    this.Create_FY_EXPORT();
    this.Selectionumber();
    this.Selectlistitem();
    this.Selectlistdepartment();
    this.selectlistcur();
    this.selectlistwhtax();
    this.Addmonthaccrue();  
    
    this.userName = this.authService.isAuthenticated() && this.auth.getDetail().ssNameTH;
    this.userCode = this.authService.isAuthenticated() && this.auth.getDetail().ssUserName;
  }

  public AddSubitem() {
    this.ShowList = false;
    this.addSubitemdetails = true;
    this.List02 = false;
    this.List03 = false;
    this.List04 = false;
    this.vocuherlist = false;
    this.claimformprint = false;
    this.params.Sub_Name = "";
    this.params.Budget_Code = "";
    this.params.Expense_Code = "";
    this.Selectlistitem();
  }

  public AddVoucher() {
    this.ShowList = false;
    this.showheader = false;
    this.addSubitemdetails = false;
    this.List02 = false;
    this.List03 = false;
    this.List04 = false;
    this.vocuherlist = true;
    this.claimformprint = false;
    this.ParamsAdd.Doc_Date = new Date();
    this.ParamsAddDetail.Doc_Date = new Date();
    this.addRow();
  }

  public AddSuppiler() {
    this.ShowList = false;
    this.addSubitemdetails = false;
    this.List02 = false;
    this.List03 = true;
    this.List04 = true;
    this.vocuherlist = false;
    this.tableData03 = [];
    this.params.Sup_Name = "";
    this.params.Sup_Code = "";
    this.params.Tax_id = "";
    this.params.Branch = "";
    this.params.Address = "";
    this.http.post("PC", "SNEN050_Sub_Supplier_List", this.AddSuppiler)
      .subscribe(res => {
        this.tableData03 = res.Table;
    
      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contract support team", this.viewref);
      });
  }

  public Search() {
    this.ShowList = false;
    this.addSubitemdetails = false;
    this.List02 = true;
    this.List03 = false;
    this.List04 = false;
    this.vocuherlist = false;
    this.claimformprint = false;
    this.tableDatavocuher = [];
    const param = {
      SUPPLIER_NAME: this.params.Supplier_Name,
      VOUCHER_NO: this.paramsSearch.VOUCHER_NO,
      NISSAN_INVOICE_NO: this.paramsSearch.NISSAN_INVOICE_NO,
      SUPPLIER_INV: this.paramsSearch.SUPPLIER_INV,
      PURPOSE: this.paramsSearch.PURPOSE

    };
    
    
    this.http.post("PC", "SNEN050_Get_Data_Vocher", param)
      .subscribe(res => {
       
        this.tableDatavocuher = res.Table;
        
      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contract support team", this.viewref);
      });


  }
  @ViewChild("headerForm") headerForm: NgForm;

  public create_monthly_Purpose() {
    for (var i = 0; i < 36; i++) {
      const month_names_short = ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December'];
      const d: any = {
        DATE: new Date(),
        DATE_DSP: 3,
        DATE_TODATE: 3,
      };
      
      d.DATE.setMonth(d.DATE.getMonth() - i)
      d.DATE_DSP = (d.DATE.getFullYear() + '' + ((d.DATE.getMonth() + 1)));
      d.DATE_DSP = (d.DATE.getFullYear() + '' + (String(d.DATE.getMonth() + 1).padStart(2, '0')));
      d.DATE_TODATE = 'ACCRUE' + ' ' + (month_names_short[d.DATE.getMonth()]) + ' ' + (d.DATE.getFullYear());
      this.monthArr.push(d);
    }
    
  }


  public Create_FY_EXPORT() {
    for (var i = 0; i < 36; i++) {
      const month_names_short = ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December'];
      const d: any = {
        DATE: new Date(),
        DATE_DSP: 3,
        DATE_TODATE: 3,
      };
      d.DATE.setMonth(d.DATE.getMonth() - i)
      // d.DATE_DSP = (d.DATE.getFullYear() + '' + ((d.DATE.getMonth() + 1)));
      d.DATE_DSP = (d.DATE.getFullYear() + '' + (String(d.DATE.getMonth() + 1).padStart(2, '0')));
      d.DATE_TODATE = (month_names_short[d.DATE.getMonth()]) + ' ' + (d.DATE.getFullYear());
      this.monthexport.push(d);
    }
  }


  public Addmonthaccrue() {
    for (var i = 0; i < 36; i++) {
      const month_names_short = ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December'];
      const d: any = {
        DATE: new Date(),
        DATE_DSP: 3,
        DATE_TODATE: 3,
      };
   
      d.DATE.setMonth(d.DATE.getMonth() - i)
      d.DATE_DSP = (d.DATE.getFullYear() + '' + ((d.DATE.getMonth() + 1)));
      d.DATE_DSP = (d.DATE.getFullYear() + '' + (String(d.DATE.getMonth() + 1).padStart(2, '0')));
      d.DATE_TODATE = 'ACCRUE' + ' ' + (month_names_short[d.DATE.getMonth()]) + ' ' + (d.DATE.getFullYear());
      this.tableaddaccrue.push(d);
    }    
  }
  public ViewData_Click() {}

  public Back() {
    this.ShowList = true;
    this.addSubitemdetails = false;
    this.List02 = false;
    this.List03 = false;
    this.List04 = false;
    this.vocuherlist = false;
    this.claimformprint = false;
  }
  public BacktoListvocher() {
    this.showheader = true;
    this.ShowList = true;
    this.addSubitemdetails = false;
    this.List02 = false;
    this.List03 = false;
    this.List04 = false;
    this.vocuherlist = false;
    this.claimformprint = false;
    this.tableaddvoucher = [];
    this.tableDetailvoucher = [];
  }

  public Supplierclamform(data) {
    this.ShowList = false;
    this.showheader = false;
    this.addSubitemdetails = false;
    this.List02 = false;
    this.List03 = false;
    this.List04 = false;
    this.vocuherlist = false;
    this.claimformprint = true;
    this.tableClaimForm = [];

    this.paramDetail.VOUCHER_CODE = data.VOUCHER_CODE;
    this.paramDetail.SUPPLIER_NAME = data.SUPPLIER_NAME;
    this.paramDetail.SUPPLIER_CODE = data.SUPPLIER_CODE;
    this.paramDetail.TAX_ID = data.TAX_ID;
    this.paramDetail.ADDRESS = data.ADDRESS;
    this.paramDetail.BRANCH = data.BRANCH;
    this.paramDetail.PURPOSE = data.PURPOSE;
    this.paramDetail.VOUCHER_DATE = data.VOUCHER_DATE;
    this.paramDetail.REMARK = data.REMARK;

    const param = {
      VOUCHER_CODE: data.VOUCHER_CODE,
    };
  
    
    this.http.post("PC", "SNEN050_Get_Voucher_Detail", param)
      .subscribe(res => {
        this.tableClaimForm = res.Table;
    
      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contract support team", this.viewref);
      });
  }

  public selectbudgetcode() {
    this.tablebudgetcode = [];
    this.http.post("PC", "SNEN050_Get_Budget_Code", null)
      .subscribe(res => {
        this.tablebudgetcode = res.Table;
      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contract support team", this.viewref);
      });

  }

  public selectexpensecode() {
    this.tableexpensecode = [];
    this.http.post("PC", "SNEN050_Get_Expense_Code", null)
      .subscribe(res => {
        this.tableexpensecode = res.Table;

      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contract support team", this.viewref);
      });

  }

  public ViewData() {
    this.tablespname = [];
    const param = {
      /*ZONE_CODE: data.ZONE_CODE*/
    };
    this.http.post("PC", "SNEN050_Post_Supplier_Name", param)
      .subscribe(res => {
        this.tablespname = res.Table;
       
      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contract support team", this.viewref);
      });

  }

  public Selectaddsupplier() {
    this.tablelistsupplieradd = [];
    const param = {};
    this.http.post("PC", "SNEN050_Post_Supplier_Name", param )
      .subscribe(res => {
        this.tablelistsupplieradd = res.Table;
      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contract support team", this.viewref);
      });
  }

  public ConfigSupplierName: any = {
    ColName: "LOOK_UP",
    ColValue: "",
    PlaceholderText: "Select SupplierName",
    SourceController: "PC",
    SourceMethodName: "SNEN050_Get_Supplier_Name",
    NoOfShowRecords: 30,
    MinLengthSearch: 0,
    UpperCase: false
  }
  public ConfigAccrue: any = {
    ColName: "LOOK_UP",
    ColValue: "",
    PlaceholderText: "Select SupplierName",
    SourceController: "PC",
    SourceMethodName: "SNEN050_Get_Supplier_Name",
    NoOfShowRecords: 30,
    MinLengthSearch: 0,
    UpperCase: false
  }

  public SelectGetSupplierName() {
    var SUPPLIER_NAME = this.ParamsAdd.Supplier_Name;   
    this.http.get("PC", "SNEN050_Get_Supplier_Name", SUPPLIER_NAME)
      .subscribe(res => {  
        // if (this.tablelistsupplieradd.length > 0) { 
          this.ParamsAdd.Vendor_Code = res.Table[0].VENDOR_CODE;
          this.ParamsAdd.Sup_Tax_Id = res.Table[0].TAX_ID;
          this.ParamsAdd.Sup_Address = res.Table[0].ADDRESS;
          this.ParamsAdd.Sup_Branch = res.Table[0].BRANCH_CODE;
        // }
      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contract support team", this.viewref);
      });
  }

  

  public SelectAddSupplierName(obj_SupName) {
    const param = {
      SUPPLIER_NAME: obj_SupName
    };      
    this.http.post("PC", "SNEN050_Post_Supplier_Name", param)
      .subscribe(res => {  
          this.ParamsAdd.Supplier_Name = res.Table[0].SUP_NAME; 
          this.ParamsAdd.Vendor_Code = res.Table[0].VENDOR_CODE;
          this.ParamsAdd.Sup_Tax_Id = res.Table[0].TAX_ID;
          this.ParamsAdd.Sup_Address = res.Table[0].ADDRESS;
          this.ParamsAdd.Sup_Branch = res.Table[0].BRANCH_CODE;
      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contract support team", this.viewref);
      });
  }

  public Selectaddcostandprofit(data) {
    const param = {
      ORDER_NO: data.DEPARTMENT
    };
    this.http.post("PC", "SNEN050_Department", param)
      .subscribe(res => {
        if (this.tablelistdepartment.length > 0) {
          data.COST_CENTER = res.Table[0].DEPARTMENT_CODE;
          data.PROFIT_CENTER = res.Table[0].PROFIT;
        }
  
      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contract support team", this.viewref);
      });
  }

  public Selectionumber() {
    this.tableionumber = [];
    this.http.post("PC", "SNEN050_Get_Io_Number", null)
      .subscribe(res => {
        this.tableionumber = res.Table;
       
      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contract support team", this.viewref);
      });
  }

  public Selectlistitem() {
    const param = {
      ITEM_ID: this.ParamsAdd.ITEM_ID
    };
  
    this.tablelistitem = [];
    this.tableDatasubitem = [];
    this.http.post("PC", "SNEN050_Sub_Item_List",param)
      .subscribe(res => {
        this.tablelistitem = res.Table;
        this.tableDatasubitem = res.Table;   
      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contract support team", this.viewref);
      });
  }

  public Selectsubitem(data) {
    const list = this.tablelistitem.find((item) => item.ITEM_ID == data.ITEM_ID);
    data.EXPENSE_ACCOUNT = list.EXPENSE_CODE;
    data.SUB_NAME = list.SUB_NAME;
  }

  public Selectlistdepartment() {
    const param = {};
    this.tablelistdepartment = [];
    this.http.post("PC", "SNEN050_Department", param)
      .subscribe(res => {
        this.tablelistdepartment = res.Table;
      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contract support team", this.viewref);
      });
  }

  public selectlistcur() {
    this.tablelistcur = [];
    this.http.post("PC", "SNEN050_Get_Cur", null)
      .subscribe(res => {
        this.tablelistcur = res.Table;
      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contract support team", this.viewref);
      });
  }

  public selectlistwhtax() {
    this.tableliswhtax = [];
    this.http.post("PC", "SNEN050_Get_Wh_Tax", null)
      .subscribe(res => {
        this.tableliswhtax = res.Table;
      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contract support team", this.viewref);
      });
  }

  public tableDatasubitem: any[] = [];
  public tableData02: any[] = [];
  public tableData03: any[] = [];
  public tableClaimForm: any[] = [];
  public tableaddvoucher: any[]= [] ;
  public tableDetailvoucher: any[]= [] ;

  

  

  public Backtoheader() {
    this.showheader = true;
    this.addSubitemdetails = false;
    this.ShowList = false;
    this.List02 = false;
    this.vocuherlist = false;
    this.claimformprint = false;
   
  }

  public totalformclaim: any = [
    {
      fieldName: "DEPARTMENT",
      value: "Total",
      show: true
    },
    {
      fieldName: "AMOUNT",
      show: true
    },
    {
      fieldName: "EXPENSE_AMOUNT",
      show: true
    },
    {
      fieldName: "INPUT_VAT",
      show: true
    },
    {
      fieldName: "WH_TAX_AMOUNT",
      show: true
    },
    {
      fieldName: "TOTAL_AMOUNT",
      show: true
    },
  ]  
  public totalvocuher: any[] = [
    {
      fieldName: 'DEPARTMENT',
      value: 'Total',
      show: true,
    },
    {
      fieldName: 'AMOUNT_THB',
      show: true,
    },
    {
      fieldName: 'EXPENSE_AMOUNT',
      show: true,
    },
    {
      fieldName: 'INPUT_VAT_AMOUNT',
      show: true,
    },
    {
      fieldName: 'WH_TAX_AMOUNT',
      show: true,
    },
    {
      fieldName: 'TOTAL_AMOUNT',
      show: true,
    },
  ];

  public Savesubitem() {
    this.modal.confirm("Do you want to save change you have made?", this.viewref,
      () => { 
        const param = {
          SUB_NAME: this.params.Sub_Name,
          BUDGET_CODE: this.params.Budget_Code,
          EXPENSE_CODE: this.params.Expense_Code,
        };
        //return false;
        this.http.post("PC", "SNEN050_Insert_Sub_Item", param)
          .subscribe(res => {
            if (res.STATUS_MSG == 'DONE') {
              this.modal.info('Transaction complete: applied and saved.', this.viewref);
              this.AddSubitem();
              //this.dialogAdd.Close();
            }
            
            else {
              console.log(res)
              this.modal.error('No change to save. Something went wrong.', this.viewref);
            }
          });
      },
      () => {}
    )
  }


  public Savesupplier() {
    this.modal.confirm("Do you want to save change you have made?", this.viewref,
      () => { 
        const param = {
          SUPPLIER_NAME: this.params.Sup_Name,
          VENDOR_CODE: this.params.Sup_Code,
          TAX_ID: this.params.Tax_id,
          BRANCH: this.params.Branch,
          ADDRESS: this.params.Address
          
        };
       
        //return false;
        this.http.post("PC", "SNEN050_Insert_Supplier", param)
        .subscribe(res => {
        
          if (res.STATUS_MSG == 'DONE') {
            this.modal.info('Transaction complete: applied and saved.', this.viewref);
            this.AddSuppiler();
            //this.dialogAdd.Close();
          }
          else {
            console.log(res)
            this.modal.error('No change to save. Something went wrong.', this.viewref);
          }
        });
      },
      () => {}
    )
  }

  

  public ReportSupplierclaimform(Vcher_CODE) {
  
    this.global.GoToReport(
      "PMS_RPT_EN_SNEN050_SUPPLIER_CLAIM_FORM",
      {
        // P_VOUCHER_CODE: this.tableClaimForm[0].VOUCHER_CODE,
        // P_VOUCHER_NO: this.tableDatavocuher[0].VOUCHER_CODE,

        P_VOUCHER_CODE: Vcher_CODE,
        P_VOUCHER_NO: Vcher_CODE,
        P_NISSAN_INVOICE_NO: '',
        P_SUPPLIER_NAME:  '',
        P_SUPPLIER_INV: '',
        P_PURPOSE:  ''
      }
    )
  }

  public Exportexcelvoucher() {
    this.global.GoToReport(
      "PMS_RPT_VOCUHER_SNENE050",
      {
        P_PURPOSE_DATE_START: this.paramSearch.P_PURPOSE_DATE_START,
        P_PURPOSE_DATE_END: this.paramSearch.P_PURPOSE_DATE_END,
      },true,false
    )
   
  }

  public ExportexcelvoucherFY() {
    this.global.GoToReport(
      "PMS_RPT_EN_VOCUHER_FY_SNENE050",
      {
        P_VOUCHER_YEAR: this.paramSearch.P_VOUCHER_YEAR,
      }
    )

  }

  public Calculate_amt(type, data) {
   
    let total_inv: number = data.TOTAL_AMOUNT_OF_INVOICE;
    let rate: number = data.RATE;
    let amt_thb: number = total_inv * rate;
    let vat: string = data.VAT;
    let wh_tax: number = data.WH_TAX;
    let expense_amt: number = 0;
    let vat_amt: number = 0;
    let wh_tax_amt: number = 0;

		//cal Expense_amt and vat
    if (vat == "VAT") {
      expense_amt = amt_thb / 1.07;
      vat_amt = expense_amt * 0.07;
    } else {
      expense_amt = amt_thb;
    }

    //cal wh_tax
    wh_tax_amt = expense_amt * wh_tax / 100;

    data.AMOUNT_THB = Math.round((amt_thb + Number.EPSILON) * 100) / 100;
    data.EXPENSE_AMOUNT = Math.round((expense_amt + Number.EPSILON) * 100) / 100;
    data.INPUT_VAT_AMOUNT = Math.round((vat_amt + Number.EPSILON) * 100) / 100;
    data.WH_TAX_AMOUNT = Math.round((wh_tax_amt + Number.EPSILON) * 100) / 100;
    this.Cal_final(data);
  }

  public Cal_final(data) {
    const expense_amt: number = data.EXPENSE_AMOUNT;
    const vat_amt: number = data.INPUT_VAT_AMOUNT;
    const wh_tax_amt: number = data.WH_TAX_AMOUNT;
    let total_amt: number = 0;
    total_amt = expense_amt + vat_amt - wh_tax_amt;
    data.TOTAL_AMOUNT = Math.round((total_amt + Number.EPSILON) * 100) / 100;
  }

  public Calculate_amt_2(data) {
    if ((data.EXPENSE_AMOUNT != "") && (data.INPUT_VAT_AMOUNT != "") && (data.WH_TAX_AMOUNT != "")) {
      this.Cal_final(data);
    }
  }


  public Invoice_Dup_Check() {
    var max = 0;  
    var ChkDataAdd=0;
    var temp_voucher_list: any= {}
    this.tableaddvoucher.map((x,index) => {     
      if (x.ACTION=='new'){
        temp_voucher_list.temp_SUPPLIER_INVOICE_NO = x.SUPPLIER_INVOICE_NO;
        temp_voucher_list.temp_SUB_ITEM=x.ITEM_ID;
        temp_voucher_list.temp_NISSAN_INVOICE_NO=x.NISSAN_INVOICE_NO; 
      }  
    });

    var dupCheck = 0;
    this.tableDetailvoucher.map((DtV,index) => { 					
        if (
            DtV.SUPPLIER_INVOICE_NO == temp_voucher_list.temp_SUPPLIER_INVOICE_NO 
            && DtV.SUB_ITEM == temp_voucher_list.temp_SUB_ITEM
            && DtV.NISSAN_INVOICE_NO == temp_voucher_list.temp_NISSAN_INVOICE_NO
        ){
          dupCheck++;   
        }
    });
    if(dupCheck > 0) {
      this.modal.info("Supplier Invoice ??? ???????????????????????", this.viewref, () => {});       
      return false;
    }

    this.tableaddvoucher.forEach((value) => {
      if (value.DOC_DATE ) {
        this.property.forEach((property) => {
          if( (value[property] == "" || value[property] == null) && value[property] != 0 ){  
            value[property + "_REQUIRED"] = true  
            ChkDataAdd++;
          }else{  
            value[property + "_REQUIRED"] = false  
          }  
        }); 
      }
    });
    if (ChkDataAdd != 0){
      this.modal.warning("???????????????? ????????????????????????????", this.viewref);
      return false;
    }

    var sendDataCheck: any = [];    
    this.tableaddvoucher.map((x,index) => {     
      if (x.ACTION=='new'){
        sendDataCheck[index] = {};
        sendDataCheck[index].V_VoucherNo = null;
        sendDataCheck[index].V_DocNo = x.SUPPLIER_INVOICE_NO;
        sendDataCheck[index].V_InvoiceNo = x.NISSAN_INVOICE_NO;
        sendDataCheck[index].V_SUPPLIER_CODE = null;

        this.http.post("PC", "SNEN050_INVOICE_DUP_CHECK", sendDataCheck[index]).subscribe(
        (res) => {
            if (res.result === "DUPLICATED") {
              this.modal.info(`Supplier Invoice ??? 
              ???????????????????????`, this.viewref, () => {});       
              return false;  
            } 
            else if (res.result === "INVOICE_USED") {
              this.modal.confirm("NISSAN Invoice ??? ???????????????????????????",this.viewref,() => {   
                  x.ACTION='Edit'
                  x.FlgAddDetail=true 
                  this.tableDetailvoucher.push({
                    'SUPPLIER_INVOICE_NO': x.SUPPLIER_INVOICE_NO,
                    'SUB_ITEM': x.ITEM_ID,
                    'NISSAN_INVOICE_NO': x.NISSAN_INVOICE_NO,
                  });               
                  this.addRow();              
                },() => {
                  return false;  
                }
              ) 
            }else{
              x.ACTION='Edit'
              x.FlgAddDetail=true 
              this.tableDetailvoucher.push({
                'SUPPLIER_INVOICE_NO': x.SUPPLIER_INVOICE_NO,
                'SUB_ITEM': x.ITEM_ID,
                'NISSAN_INVOICE_NO': x.NISSAN_INVOICE_NO,
              }); 
              this.addRow();
            }              
          },
          (err) => {
            this.modal.error("???????????????? ????????????????????",this.viewref);
          }
        );
      }
    })
  }

  public addRow() {   
    
    this.tableaddvoucher.push({
      'ACTION': "new",
      'ITEM': null,
      'DOC_DATE': new Date(),
      'SUPPLIER_INVOICE_NO': null,
      'SUB_ITEM': null,
      'NISSAN_INVOICE_NO': null,
      'DEPARTMENT': null,
      'COST_CENTER': null,
      'PROFIT_CENTER': null,
      'IO_NUMBER': null,
      'CUR':null,
      'TOTAL_AMOUNT_OF_INVOICE': null,
      'RATE': 1,
      'AMOUNT_THB': null,
      'VAT': null,
      'WH_TAX': null,
      'EXPENSE_AMOUNT': 0,
      'INPUT_VAT_AMOUNT': 0,
      'WH_TAX_AMOUNT': 0,
      'TOTAL_AMOUNT': 0,
      'FlgAddDetail': false,
    });
    this.tableaddvoucher = this.tableaddvoucher.slice();
    this.PageAction = PageAction.Retrive;     
 
  }

 
  public DeleteRow(Item) {
    if (this.PageAction == PageAction.Retrive) {
      let Row = this.tableaddvoucher.findIndex(x => x == Item)
      this.tableaddvoucher.splice(Row, 1);
      this.tableaddvoucher = this.tableaddvoucher.slice();
    }
  }

  
 
  public SaveVoucher() {   
    let P_DOC_DATE= this.ParamsAdd.Doc_Date;
    let P_DOC_Year=P_DOC_DATE.getFullYear();
    let P_DOC_MONTH=P_DOC_DATE.getMonth() + 1;
    let V_VoucherNo=null;

    var i: number = 0;
    this.ParamsAdd.P_DOC_DATE =P_DOC_DATE;
    this.ParamsAdd.REGISYEAR = P_DOC_Year; 
    this.ParamsAdd.REGISMONTH = P_DOC_MONTH;      
    var sendData: any = [];
    this.tableaddvoucher.forEach((value) => {
      if (value.ACTION == 'Edit' ) {
        sendData[i] = {};
        sendData[i].DOC_DATE = this.global.ConvertDateToFormatSTD(value.DOC_DATE);
        sendData[i].SUPPLIER_INVOICE_NO = value.SUPPLIER_INVOICE_NO;
        sendData[i].NISSAN_INVOICE_NO = value.NISSAN_INVOICE_NO;
        sendData[i].EXPENSE_ACCOUNT = value.EXPENSE_ACCOUNT;
        sendData[i].DEPARTMENT = value.DEPARTMENT;
        sendData[i].COST_CENTER = value.COST_CENTER;
        sendData[i].PROFIT_CENTER = value.PROFIT_CENTER;
        sendData[i].IO_NUMBER = value.IO_NUMBER;
        sendData[i].CUR = value.CUR;
        sendData[i].ITEM_ID = value.ITEM_ID;
        sendData[i].TOTAL_AMOUNT_OF_INVOICE = value.TOTAL_AMOUNT_OF_INVOICE;
        sendData[i].RATE = value.RATE;
        sendData[i].AMOUNT_THB = value.AMOUNT_THB;
        sendData[i].VAT = value.VAT;
        sendData[i].WH_TAX = value.WH_TAX;
        sendData[i].EXPENSE_AMOUNT = value.EXPENSE_AMOUNT;
        sendData[i].INPUT_VAT_AMOUNT = value.INPUT_VAT_AMOUNT;
        sendData[i].WH_TAX_AMOUNT = value.WH_TAX_AMOUNT;
        sendData[i].TOTAL_AMOUNT = value.TOTAL_AMOUNT; 
        i = i + 1;
      }      
    });       
    
    if (this.ParamsAdd.Supplier_Name == ''  || this.ParamsAdd.Supplier_Name == null ){
      this.modal.warning("กรุณาเลือก Supplier Name", this.viewref);
      this.ParamsAdd.Supplier_Name.focus();
      return false;
    }
    if (this.ParamsAdd.accrue == ''  || this.ParamsAdd.accrue == null ){
      this.modal.warning("กรุณาเลือก Purpose", this.viewref);
      this.ParamsAdd.accrue.focus();
      return false;
    }
    if (i == 0){
      this.modal.warning("กรุณายืนยันการเพิ่มรายการก่อนบันทึก", this.viewref);
      return false;
    }

    const paramSaveData = {
      HEADER: this.ParamsAdd,
      DETAIL: sendData
    }
    
   // return false;
    //  return;
    this.modal.confirm(
      "คุณต้องการบันทึกการทำงานใช่หรือไม่",
      this.viewref,
      () => {  
        this.http.post("PC", "SNEN050_Insert_Voucher_Detail", paramSaveData).subscribe(
          (res) => {
            if (res.result === "DONE") {
              this.modal.info(`บันทึกเสร็จสิ้น`, this.viewref, () => {});
              this.tableaddvoucher = [];              
            } 
            else if (res.result === "FAIL") {
              this.modal.error(res.message, this.viewref);
            } 
            else {
              this.modal.error("พบปัญหาการใช้งาน กรุณาแจ้งผู้ดูแลระบบ",this.viewref);
            }
            let VoucherNo_var =res.voucherNo ;      
            this.SupplierCamView(VoucherNo_var);         
          },
          (err) => {
            this.modal.error("พบปัญหาการใช้งาน กรุณาแจ้งผู้ดูแลระบบ",this.viewref);
          }          
        );
      },
      () => {}
    );
  }

  public SupplierCamView(VoucherNo_var) {
    this.ShowList = false;
    this.showheader = false;
    this.addSubitemdetails = false;
    this.List02 = false;
    this.List03 = false;
    this.List04 = false;
    this.vocuherlist = false;
    this.claimformprint = true;
    this.tableClaimForm = [];
    this.paramDetail.VOUCHER_CODE = VoucherNo_var;
    this.paramDetail.SUPPLIER_NAME = this.ParamsAdd.Supplier_Name;
    this.paramDetail.SUPPLIER_CODE = this.ParamsAdd.Vendor_Code;
    this.paramDetail.TAX_ID = this.ParamsAdd.Sup_Tax_Id;
    this.paramDetail.ADDRESS = this.ParamsAdd.Sup_Address;
    this.paramDetail.BRANCH = this.ParamsAdd.Sup_Branch;
    this.paramDetail.PURPOSE = this.ParamsAdd.accrue;
    this.paramDetail.VOUCHER_DATE = moment(this.ParamsAdd.Doc_Date).format("DD-MM-yyyy");
    this.paramDetail.REMARK = this.ParamsAdd.REMARK;
    const param = {
      VOUCHER_CODE: VoucherNo_var,
    };
    this.http.post("PC", "SNEN050_Get_Voucher_Detail", param)
      .subscribe(res => {   
        this.tableClaimForm = res.Table;
        this.ParamsAdd= {}; 
      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contract support team", this.viewref);
      });
  }
}





