import { Component, OnInit, Input, Output, EventEmitter, TemplateRef, ContentChild, ViewChild, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Router } from '@angular/router';
import { Globals } from 'src/app/core/global';
import { ModalService } from '../../../core/modal.service';
import * as moment from 'moment';
import { DialogTemplateComponent } from 'src/app/components/shared/dialog-template/dialog-template.component';
import { MatDatepicker } from '@angular/material/datepicker';
import { log } from 'console';

@Component({
  selector: 'SNEN051',
  templateUrl: './SNEN051.component.html',
  styleUrls: ['./SNEN051.component.css']
})


export class SNEN051Component implements OnInit {


  constructor(
    private http: HttpService,
    private router: Router,
    private modal: ModalService,
    private viewref: ViewContainerRef,
    private global: Globals
  ) { }

  public CustomerList: any = [];
  public tableData: any = [];
  public tableData_VOR: any = [];
  public DataGetReject: any = [];
  public DataGetApprove: any = [];
  public tableData1: any = [];
  public tableData2: any = [];
  public dataReject: any = [];
  public tableSelect: any = [];
  public param: any = {}
  public params: any = {}
  public showList: Boolean;
  public htmlstring: any = {};
  public solution_text: any = {};
  public print_text: any = {};
  public print_inv: any = {};
  public paramsHead: any = {};
  public paramDetail: any = {};
  public paramSearch: any = {};
  public paramReject: any = {};
  public formData: any = {};
  public formDataReject: any = {};

  public numbers: Array<any> = [];
  public numbers2: any = {};
  public monthArr: any = [];

  public selectedIndex: number;

  public show: boolean = false;
  public show2: boolean = true;
  public buttonName: any = 'Show';
  public buttonName2: any = 'Show';

  public tableReject: any[] = [
    { ID: "1", REJECT_NAME: "GARAGE"},
    { ID: "2", REJECT_NAME: "WHOLESALE"},
    { ID: "3", REJECT_NAME: "NOT CHASSIS NO AND JOB NO"},
    { ID: "4", REJECT_NAME: "ไม่มี BACK ORDER"},
    { ID: "5", REJECT_NAME: "มีของใน O/H"},
    { ID: "6", REJECT_NAME: "เลขแชซซีไม่ตรงกับเบอร์ที่สั่ง"},
    { ID: "7", REJECT_NAME: "ดำเนินการจัดส่งแล้ว"},
    { ID: "8", REJECT_NAME: "อื่นๆ"},
  ];

  ngOnInit(): void {
    this.selectedIndex = 0;
    this.showList = false;
    this.create_year_for_select();
    this.SolutionSelect();
    this.paramSearch.MONTHLY = (new Date().getFullYear() + '' + ((String(new Date().getMonth() + 1).padStart(2, '0')))),
    this.paramSearch.SELECT_STATUS = 0;
    this.paramSearch.SEARCH_PO = '' ;
    this.formData.SELECT_VOR = '';
    this.formData.REMARK = '';
   // this.ViewData_Click();
    this.GetDetail();
  }
  @ViewChild("dialogAdd", { static: false }) dialogAdd: any;
  @ViewChild("dialogReject", { static: false }) dialogReject: any;
  @ViewChild("dialogRejectAll", { static: false }) dialogRejectAll: any;
  @ViewChild("dialogUpdate", { static: false }) dialogUpdate: any;
  @ViewChild("dialogCancel", { static: false }) dialogCancel: any;

  public create_year_for_select() {   
    for (var i = 0; i < 36; i++) {
      const month_names_short = ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'];
      const d: any = {
        DATE: new Date(),
        DATE_DSP: 3,
        DATE_TODATE: 3,
      };
      d.DATE.setMonth(d.DATE.getMonth() - i)
     // d.DATE_DSP = (d.DATE.getFullYear() + '' + ((d.DATE.getMonth() + 1)));
      d.DATE_DSP = (d.DATE.getFullYear() + '' + (String(d.DATE.getMonth() + 1).padStart(2, '0')));
      d.DATE_TODATE = (month_names_short[d.DATE.getMonth()]) + ' ' + (d.DATE.getFullYear());
      this.monthArr.push(d);
    }
  }

  public ViewData_Click() {
    this.showList = false;
    this.GetDetail();
   // this.DetailFilter(this.paramSearch.SELECT_STATUS)
  }



  public GetDetail() {
    this.showList = false;
    this.tableData = [];
    const params = {
      SEARCH_PO: this.paramSearch.SEARCH_PO,
      MONTHLY: this.paramSearch.MONTHLY,
    };
    //console.log('params >> ', params);
    this.http.post("PC", "SNEN051_GetData", params)
      .subscribe(res => {
  //  console.log('res >> ' ,res);
        this.tableData = res.Table;
        this.tableData.forEach((d) => {
          if (d.BRANCH_NAME_TH) {
            d.CUSTOMER_NAME = d.BRANCH_NAME_EN + " " + d.BRANCH_NAME_TH;
          } else {
            d.CUSTOMER_NAME = d.BRANCH_NAME_EN ;
          }

          if (d.PENDING_AP != "0") {
            d.REMARK = "รออนุมัติ"
            d.PRINT_APPROVE = 1; // red
          } else if (d.REMAIN_QTY != "0" && d.PENDING_AP == "0") {
            d.REMARK = "รอจัดส่ง"
            d.PRINT_APPROVE = 2; //blue
          } else if (d.REMAIN_QTY == "0" && d.ALL_DETAIL != "0") {
            d.REMARK = "Complete"
            d.PRINT_APPROVE = 3; //green
          } else if (d.ALL_DETAIL == "0") {
            d.REMARK = "ไม่พบข้อมูล"
            d.PRINT_APPROVE = ""; //no color
          } else {
            d.REMARK = "รออนุมัติ"
            d.PRINT_APPROVE = 1; // red
          }

          d.VOR_DATE = moment(d.VOR_DATE, "YYYY-MM-DD").format('D MMM YYYY');
        
        })
     this.DetailFilter(this.paramSearch.SELECT_STATUS)
      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contract support team", this.viewref);
      });   
  }


  public DetailFilter(ID) {

    console.log('ID',ID);
    if (ID == '0' || ID == '1') {
      this.tableData = this.tableData;
    } else if (ID !== '0') {
      let tempData = this.tableData.filter(v => v.REMARK == ID);
      this.tableData = tempData;
    }

   // const parms = this.tableData.filter(element => { element.REMARK = this.paramSearch.SELECT_STATUS; return element });

  }

  public ViewSearch(data) {
   // console.log('data',data)
    this.showList = true;
    this.tableData1 = [];
    this.tableData2 = [];
    const param = {
      CUSTOMER_CODE: data.CUSTOMER_CODE,
      BRANCH_CODE: data.BRANCH_CODE,
      VOR_NO: data.VOR_NO
    };
   //console.log(' param >>>  ', param)
    this.http.post("PC", "SNEN051_GetData_ViewSearch", param)
      .subscribe(res => {
      //console.log(' res >>>  ', res)
        this.tableData1 = res.Table;
        this.tableData2 = res.Table1;
             
       
        if (this.tableData1.length > 0) {
          this.paramDetail.VOR_NO_ID = this.tableData1[0].VOR_NO;
          this.paramDetail.VOR_DATE = moment(this.tableData1[0].VOR_DATE_SHOW, "YYYY-MM-DD").format('D MMM YYYY');
          this.paramDetail.CTM_CODE = this.tableData1[0].CUSTOMER_CODE;
          this.paramDetail.BR_CODE = this.tableData1[0].BRANCH_CODE;
          if (this.tableData1[0].BRANCH_NAME_TH != null) {
            this.paramDetail.CTM_NAME = (this.tableData1[0].BRANCH_NAME_EN + " - " + this.tableData1[0].BRANCH_NAME_TH);
          } else {
            this.paramDetail.CTM_NAME = this.tableData1[0].BRANCH_NAME_EN;
          }
          this.paramDetail.DMS_CODE = this.tableData1[0].DMS_DEALERID;
          this.paramDetail.JOB_NO = this.tableData1[0].DMSJOBNO;
          this.paramDetail.CHASSIS_NO = this.tableData1[0].CHASSISNO;
          this.paramDetail.MODEL = this.tableData1[0].MODELCODE;
          this.paramDetail.PLATE_NO = this.tableData1[0].PLATENO;
          this.paramDetail.CREATE_TIME = moment(this.tableData1[0].REC_DATE, "YYYY-MM-DD HH:mm").format('D MMM YYYY HH:mm');
        }

        if (this.tableData2.length > 0) {
          var count_approve = 0;
          
          this.tableData2.forEach((d) => {

            d.VOR_NO = this.tableData1[0].VOR_NO;
            d.CUSTOMER_CODE = this.tableData1[0].CUSTOMER_CODE;
            d.BRANCH_CODE = this.tableData1[0].BRANCH_CODE;
           //console.log('VOR_STATUS >> > ', d.VOR_STATUS);
            switch (d.VOR_STATUS) {
              case "N":
                d.STATUS = "New";
                d.PRINT_COLOR = 1; // bg-light-blue
                //d.STATUS_NAME = "";
                break;
              case "A":
                d.STATUS = "Approved";
                d.PRINT_COLOR = 1; // bg-light-blue
                d.STATUS_NAME = moment(d.AR_DATE, "YYYY-MM-DD HH:mm").format('D MMM YY HH:mm');
                break;
              case "R":
                d.STATUS = "Reject";
                d.PRINT_COLOR = 2; // bg-red
                d.STATUS_NAME = moment(d.AR_DATE, "YYYY-MM-DD HH:mm").format('D MMM YY HH:mm');
                break;
              case "D":
                d.STATUS = "Delivery";
                d.PRINT_COLOR = 3; // bg-green
                d.STATUS_NAME = "Approve : " + moment(d.AR_DATE, "YYYY-MM-DD HH:mm").format('D MMM YY HH: mm');
                break;
              case "C":
                d.STATUS = "Cancelled";
                d.PRINT_COLOR = 4; // bg-Gray
                d.STATUS_NAME = "Approve : " + moment(d.AR_DATE, "YYYY-MM-DD HH:mm").format('D MMM YY HH: mm');
                break;
              default:
                console.log("action not macth")
                break;
            }

            if (d.SOLUTION != null) {
              d.solution_text = d.SOLUTION_ID + " " + d.SOLUTION_DESC;
              d.solution_text2 = d.SOLUTION_ADD;
            }
           
            //d.VOR_STATUS = '';
            if (d.VOR_STATUS == "N") {

              count_approve += 1;
              
              //console.log('d.countApprve', d.countApprve)
              d.print_text = "Reject"
              d.htmlstring = "Approve"

            } else if (d.VOR_STATUS == "R") {
              d.print_text = ""
              d.htmlstring = d.ATTRIBUTE1;

            }
            else if (d.VOR_STATUS == "C") {
              d.print_text = ""
              d.htmlstring = d.ATTRIBUTE1;
            } else if (d.VOR_STATUS == "D") {

              if (d.ATTRIBUTE2 == null) {
                d.print_inv = "ยังไม่ออก DO"
                d.print_text = d.print_inv;
              }
             
              if (d.ATTRIBUTE2 != null) {
                d.print_inv = ""
                d.print_text2 = d.ATTRIBUTE2;
                d.print_text3 = moment(d.INV_DATE, "YYYY-MM-DD").format('D MMM YY');
                d.print_text4 = "Part : " + d.ACCEPT_PART_NO;
                d.print_text = d.print_inv;
              }
              d.htmlstring = "วิธีการ"
            }
            else {
              var rnd_id = this.makeid();
            //  console.log('rnd_id >', rnd_id);
              d.etd_text = " - ";
              if (d.ETD_DATE != null) {
                d.etd_text = moment(d.ETD_DATE, "YYYY-MM-DD").format('D MMM YYYY')
              }

              d.print_text = "กำหนดส่ง : " + d.etd_text
              d.print_text2 = "วิธีการ"

              d.htmlstring = "บันทึก Borrow Sheet"
              d.htmlstring2 = "Cancel"

            }
          })

          this.paramsHead.countApprve = count_approve;
        }

      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contract support team", this.viewref);
      });
  }

  public SolutionSelect() {
    this.tableSelect = [];
    this.http.post("PC", "SNEN051_GetData_SolutionSelect", null)
      .subscribe(res => {
        this.tableSelect = res.Table;
      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contract support team", this.viewref);
      });
  }

  OpenDialog(data) {
    this.formData = data;
    this.formData.SELECT_VOR = "";
    this.formData.REMARK = ""; 
    this.dialogAdd.OpenDialog();

  }

  UpdateDialog(data) {
    this.formData = data;
    this.dialogUpdate.OpenDialog();
    this.formData.BORROW_SHEET_DATE = new Date();
    this.formData.BORROW_SHEET_NO_PANEL = "";
    //console.log('formData >>>> ', this.formData);
  }


  CancelDialog(data) {
    this.formData = data;
    this.dialogCancel.OpenDialog();
    this.formData.REASON = "ลูกค้าขอยกเลิก VOR";
    this.GetData_VOR();
  }

 
  RejectDialog(data) {
    this.formDataReject = data;
    this.dialogReject.OpenDialog();
    this.GetReject();
    this.formData.REJECT_NAME = "1";
    //if (this.formData.REJECT_NAME != "8") {
    //  (<HTMLInputElement>document.getElementById("Reject")).disabled = true;
    //}
   // this.DataReject_Click();
  }

  public SaveEdit() {
    this.modal.confirm("Do you want to save change you have made?", this.viewref)
    const param = {
      VOR_NO: this.formData.VOR_NO,
      CUSTOMER_CODE: this.formData.CUSTOMER_CODE,
      BRANCH_CODE: this.formData.BRANCH_CODE,
      ITEM_NO: this.formData.ITEM_NO,
      SUB_ITEM_NO: this.formData.SUB_ITEM_NO,
      UPDATE_SOLOTION: this.formData.SELECT_VOR + "-" + this.formData.REMARK

    };
    this.http.post("PC", "SNEN051_UpdateData", param)
      .subscribe(res => {
        if (res.STATUS_MSG == 'DONE') {
          this.modal.info('Transaction complete: applied and saved.', this.viewref);
          this.GetDetail();
          this.ViewSearch(param);
          this.dialogAdd.Close();
        }
        else {
          console.log(res)
          this.modal.error('No change to save. Something went wrong.', this.viewref);
        }
      })
  }

  public GetData_VOR() {
    this.tableData_VOR = [];
    const param = {
      VOR_NO: this.formData.VOR_NO,
      CUSTOMER_CODE: this.formData.CUSTOMER_CODE,
      BRANCH_CODE: this.formData.BRANCH_CODE,
      ITEM_NO: this.formData.ITEM_NO,
    };
   // console.log('param >> ', param)
    this.http.post("PC", "SNEN051_GetData_VOR", param)
      .subscribe(res => {
       // console.log('res > > ',res)
        this.tableData_VOR = res.Table;
      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contract support team", this.viewref);
      });
  }
  

  public SaveCancel() {
    const params = {
      VOR_NO: this.formData.VOR_NO,
      CUSTOMER_CODE: this.formData.CUSTOMER_CODE,
      BRANCH_CODE: this.formData.BRANCH_CODE,
      ITEM_NO: this.formData.ITEM_NO,
      REASON: this.formData.REASON,
      SUB_ITEM_NO: this.tableData_VOR[0].SUB_ITEM_NO,
      ACCEPT_QTY: this.tableData_VOR[0].ACCEPT_QTY,
      REF_ORDER_NO: this.tableData_VOR[0].REF_ORDER_NO,
      REF_ITEM_NO: this.tableData_VOR[0].REF_ITEM_NO,
      REF_SUB_ITEM_NO: this.tableData_VOR[0].REF_SUB_ITEM_NO,

    };
    // console.log('params >> ', params)
    this.http.post("PC", "SNEN051_CancelVOR", params)
      .subscribe(res => {
        if (res.STATUS_MSG == 'DONE') {
          this.modal.info('ยกเลิก VOR สำเร็จ', this.viewref);
          this.GetDetail();
          this.ViewSearch(params);
          this.dialogCancel.Close();
        }
        else {
          console.log(res)
          this.modal.error('No change to save. Something went wrong.', this.viewref);
        }
      })

  }

  public SaveBorrow() {
    if (this.formData.BORROW_SHEET_NO_PANEL == "") {
      this.modal.info('กรุณากรอกข้อมูล Borrow Sheet No', this.viewref);
    } else {
      //this.modal.confirm("Do you want to save change you have made?", this.viewref)
      const param = {
        VOR_NO: this.formData.VOR_NO,
        CUSTOMER_CODE: this.formData.CUSTOMER_CODE,
        BRANCH_CODE: this.formData.BRANCH_CODE,
        ITEM_NO: this.formData.ITEM_NO,
        SUB_ITEM_NO: this.formData.SUB_ITEM_NO,
        BORROW_SHEET_NO: this.formData.BORROW_SHEET_NO_PANEL,
        BORROW_SHEET_DATE: this.formData.BORROW_SHEET_DATE,
        BORROW_SHEET_QTY: this.formData.ORDER_QTY,

      };

      this.http.post("PC", "SNEN051_SaveBorrow", param)
        .subscribe(res => {
        if (res.STATUS_MSG == 'DONE') {
          this.modal.info('Transaction complete: applied and saved.', this.viewref);
          this.GetDetail();
          this.ViewSearch(param);
          this.dialogUpdate.Close();
        }
        else {
          console.log(res)
          this.modal.error('No change to save. Something went wrong.', this.viewref);
        }
      })
    }
   
  }



  CancelAdd() {
    this.dialogAdd.Close();
  }

  CancelUpdate() {
    this.dialogUpdate.Close();
  }

  Cancel() {
    this.dialogCancel.Close();
  }
  
  RejectClose() {
    this.dialogReject.Close();
  }

  //Edit(data) {
  //  this.dialogEdit.OpenDialog();
  //}

  public toggle(data) {
    data.NEW_ETD_DATE = "";
    let bool = data.IS_EDIT;
    bool = !bool;
    data.IS_EDIT = bool;
  }

  public OpendateFromPopup(datepicker: MatDatepicker<any>) {
    datepicker.open();
    this.params.DATE_FROM = new Date();

  }

  public save_new_etd(data) {
    const param = {
      VOR_NO: data.VOR_NO,
      CUSTOMER_CODE: data.CUSTOMER_CODE,
      BRANCH_CODE: data.BRANCH_CODE,
      ITEM_NO: data.ITEM_NO,
      SUB_ITEM_NO: data.SUB_ITEM_NO,
      NEW_ETD_DATE: moment(data.NEW_ETD_DATE, 'DD/MM/YYYY').format('YYYY-MM-DD')
        
    };
    this.http.post("PC", "SNEN051_save_new_etd", param)
      .subscribe(res => {
        if (res.STATUS_MSG == 'DONE') {
          this.modal.info('Transaction complete: applied and saved.', this.viewref);
          this.GetDetail();
          this.ViewSearch(param);
        }
        else {
          console.log(res)
          this.modal.error('No change to save. Something went wrong.', this.viewref);
        }
      })
  }



  public Report() {
    this.global.GoToReport(
      "PMS_RPT_EN_SNEN051",
      {
        P_MONTHLY: this.paramSearch.MONTHLY,
      }
    )
  }


  public makeid() {
    var text = "";
    var possible = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";

    for (var i = 0; i < 15; i++)
      text += possible.charAt(Math.floor(Math.random() * possible.length));
    return text;
  }

  public DataReject_Click() { 
   // console.log('REJECT_NAME', this.formDataReject.REJECT_NAME);
    if (this.formData.REJECT_NAME == '8') {
      (<HTMLInputElement>document.getElementById("Reject")).disabled = false;
    } else {
      (<HTMLInputElement>document.getElementById("Reject")).disabled = true;
    }
  }

  public DataRejectAll_Click() {

    if (this.formData.REJECTALL_NAME == '8') {
      (<HTMLInputElement>document.getElementById("RejectAll")).disabled = false;
    } else {
      (<HTMLInputElement>document.getElementById("RejectAll")).disabled = true;
    }
  }


  public GetReject() {
    this.DataGetReject = [];
   // this.modal.confirm("Do you want to save change you have made?", this.viewref)
    const param = {
      VOR_NO: this.formDataReject.VOR_NO,
      CUSTOMER_CODE: this.formDataReject.CUSTOMER_CODE,
      BRANCH_CODE: this.formDataReject.BRANCH_CODE,
      ITEM_NO: this.formDataReject.ITEM_NO,
      SUB_ITEM_NO: this.formDataReject.SUB_ITEM_NO,
      UPDATE_REJECT_REMARK: this.formDataReject.REJECT_REMARK

    };
   // console.log('param >> ', param);
    this.http.post("PC", "SNEN051_GetRejectData", param)
      .subscribe(res => {
      //  console.log('res > > ',res)
        this.DataGetReject = res.Table;
      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contract support team", this.viewref);
      });
    
  }


  public SaveReject() {
  //  this.modal.confirm("Do you want to save change you have made?", this.viewref)
    const param = {
      VOR_NO: this.formDataReject.VOR_NO,
      CUSTOMER_CODE: this.formDataReject.CUSTOMER_CODE,
      BRANCH_CODE: this.formDataReject.BRANCH_CODE,
      ITEM_NO: this.formDataReject.ITEM_NO,
      SUB_ITEM_NO: this.formDataReject.SUB_ITEM_NO,
      UPDATE_REJECT_REMARK: this.formData.REJECT_REMARK,
      REF_ORDER_NO :this.DataGetReject[0].REF_ORDER_NO,
		  REF_ORDER_DATE :this.DataGetReject[0].REF_ORDER_DATE,
		  REF_ITEM_NO :this.DataGetReject[0].REF_ITEM_NO,
		  REF_SUB_ITEM_NO :this.DataGetReject[0].REF_SUB_ITEM_NO,
    //  REJECT_NAME: this.formData.REJECT_NAME

    };
   //console.log('> > >',param);
    this.http.post("PC", "SNEN051_UpdateRejectData", param)
      .subscribe(res => {
        if (res.STATUS_MSG == 'DONE') {
          this.modal.info('Transaction complete: applied and saved.', this.viewref);
          this.GetDetail();
          this.ViewSearch(param);         
          this.dialogReject.Close();
        }
        else {
          console.log(res)
          this.modal.error('No change to save. Something went wrong.', this.viewref);
        }
      })
  }




  SaveRejectAll() {
   // console.log('this.tableData2 >> ', this.tableData2);
   
    if (this.tableData2.length != 0) {
      this.modal.confirm('Do you want to update on this data?', this.viewref, this.reUpdateReject)
    } else {
      this.modal.info('Please select data.', this.viewref);
    }
  }

  reUpdateReject = () => {
    const parms = this.tableData2.map(element => { element.UPDATE_REJECT_REMARK = this.formData.REJECTALL_REMARK; return element }); // ส่งค่า input ไปกับ tableData เพื่อ Update
    const param = {
      VOR_NO: this.tableData1[0].VOR_NO,
      CUSTOMER_CODE: this.tableData1[0].CUSTOMER_CODE,
      BRANCH_CODE: this.tableData1[0].BRANCH_CODE
    };
   // console.log(param);
    this.http.post('PC', 'SNEN051_UpdateRejectAllData', parms)
      .subscribe(res => {
        if (res.Table[0].STATUS == 'Done') {
          this.modal.info('Done.', this.viewref);
          this.dialogRejectAll.Close();
          this.GetDetail();
          this.ViewSearch(param);
          
        }
        else {
          this.modal.warning(res.Table[0].MESSAGE, this.viewref);
        }
      })
  }



  SaveApproveAll() {
    if (this.tableData2.length != 0) {
      this.modal.confirm('Do you want to update on this data?', this.viewref, this.reUpdateApprove)
    } else {
      this.modal.info('Please select data.', this.viewref);
    }
  }

  reUpdateApprove = () => {
    const param = {
      VOR_NO: this.tableData1[0].VOR_NO,
      CUSTOMER_CODE: this.tableData1[0].CUSTOMER_CODE,
      BRANCH_CODE: this.tableData1[0].BRANCH_CODE
    };
    this.http.post('PC', 'SNEN051_UpdateApproveAllData', this.tableData2)
      .subscribe(res => {
        if (res.Table[0].STATUS == 'Done') {
          this.modal.info('อนุมัติสำเร็จ', this.viewref);
          this.GetDetail();
          this.ViewSearch(param);
        }
        else {
          this.modal.warning(res.Table[0].MESSAGE, this.viewref);
        }
      })
  }
  
 

  public Approve(data) {
    this.DataGetApprove = [];
    const param = {
      VOR_NO: data.VOR_NO,
      CUSTOMER_CODE: data.CUSTOMER_CODE,
      BRANCH_CODE: data.BRANCH_CODE,
      ITEM_NO: data.ITEM_NO  
    };

  //  console.log('param', param);
    this.http.post("PC", "SNEN051_GetApproveData", param)
      .subscribe(res => {
      //  console.log('res > > ',res)
        this.DataGetApprove = res.Table;
        if (this.DataGetApprove.length > 0) {
          const param = {
            VOR_NO: data.VOR_NO,
            CUSTOMER_CODE: data.CUSTOMER_CODE,
            BRANCH_CODE: data.BRANCH_CODE,
            ITEM_NO: data.ITEM_NO,
            REF_ORDER_NO: this.DataGetApprove[0].REF_ORDER_NO,
            REF_ORDER_DATE: this.DataGetApprove[0].REF_ORDER_DATE,
            REF_ITEM_NO: this.DataGetApprove[0].REF_ITEM_NO,
            REF_SUB_ITEM_NO: this.DataGetApprove[0].REF_SUB_ITEM_NO,
            TEMP_ORDER_PART_NO: this.DataGetApprove[0].ORDER_PART_NO

          };
          this.http.post("PC", "SNEN051_UpdateApproveData", param)
            .subscribe(res => {
              if (res.STATUS_MSG == 'DONE') {
                this.modal.info('อนุมัติสำเร็จ', this.viewref);
                this.GetDetail();
                this.ViewSearch(param);
                
               // this.dialogReject.Close();
              }
              else {
                console.log(res)
                this.modal.error('No change to save. Something went wrong.', this.viewref);
              }
            })

          console.log('param', param);
        }       
      }, (err) => {
        console.log(err, 'err')
        this.modal.warning("Found an error, please contract support team", this.viewref);
      });


  }

  RejectAllDialog() {
    this.GetReject();
    this.formData.REJECTALL_NAME = "1";
    this.dialogRejectAll.OpenDialog();
  }

  RejectAllClose() {
    this.dialogRejectAll.Close();
  }









}

