import { Component, OnInit, ViewContainerRef, ViewChild } from "@angular/core";
import { HttpService } from 'src/app/core/http.service';
import { ModalService } from '../../../core/modal.service';
import { AuthDecode } from '../../../core/auth-decode.service';
import { ActivatedRoute } from '@angular/router';
import { Globals } from 'src/app/core/global';
import { SelectionModel } from "@angular/cdk/collections";



@Component({
  selector: 'snm002p',
  templateUrl: './SNM002P.component.html',
  styleUrls: ['./SNM002P.component.css']
})

export class SNM002PComponent implements OnInit {

  constructor(
    private HttpService: HttpService,
    private modal: ModalService,
    private viewref: ViewContainerRef,
    private auth: AuthDecode,
    private route: ActivatedRoute,
    private global: Globals
  ) {

  }

  @ViewChild("dialogEdit", { static: false }) dialogEdit: any;
  @ViewChild("dialogAdd", { static: false }) dialogAdd: any;

  public Price_TermCode_List: any = [];
  public Gtop_Status_List: any = [];
  public Oversea_Flag_List: any = [];
  public Vendor_Type_List: any = [];
  public CustomerList: any;
  private Vender_Code: string = '';
  public qPRINT_PRICE: boolean = true;
  public qPRINT_PO: boolean = true;
  public qPRINT_STICKER: boolean = true;
  public qCPS_FLAG: boolean = false;
  public qMASTER_CHECK: boolean = false;
  public Country_Mater: any = [];
  public Vat_Master: any = [];
  public Currency_Master: any = [];
  public Staff_MAster: any = [];
  public CheckRole: boolean = false;
  public Datatable: any = [];

  public OrderClass : any = [];
  public FlagData: any = [];

  public old: string;
  public qPRINT_PRICE_ADD: boolean = true;
  public qPRINT_PO_ADD: boolean = true;
  public qPRINT_STICKER_ADD: boolean = true;
  public qCPS_FLAG_ADD: boolean = false;
  public qMASTER_CHECK_ADD: boolean = false;
  public selection = new SelectionModel<any>(true, []);

  public Data: any = {

    ADD_STOCK_LEVEL: '0.00',
    AP_SUB_TYPE: null,
    AP_VENDOR_CODE: "XX",
    ATTRIBUTE1: null,
    ATTRIBUTE2: null,
    ATTRIBUTE3: null,
    ATTRIBUTE4: null,
    ATTRIBUTE5: null,
    CALCULATE_PRICE: 'Y',
    COMPANY_CODE: null,
    COUNTRY_CODE: null,
    CPS_FLAG: null,
    CURRENCY_CODE: null,
    ENAME: null,
    FQO_FLAG: "Y",
    GLOBAL_COUNTRY_CODE: null,
    GTOP_STATUS: "N",
    LEAD_TIME_OFF: '0.00',
    LEAD_TIME_ON: '0.00',
    MAPPING_ATTRIBUTE1: null,
    METHOD_ISC: null,
    METHOD_PRICE: null,
    ORDER_INTERVAL: '0.00',
    OVERSEA_FLAG: "D",
    PAYMENT_TERM: 1,
    PAYMENT_TYPE: '2',
    PRICE_TERM_CODE: "N",
    PRINT_PO: "Y",
    PRINT_PRICE: "Y",
    PRINT_STICKER: "Y",
    PRN_PART_FORMAT: null,
    SAP_PAYMENT_TERM: null,
    SK_USER_ID: null,
    SOURCING_CODE: null,
    STD_SAFE_STOCK: '0.00',
    SUGGEST_FLAG: "N",
    TNAME: null,
    TOP_VALUE_ITEMS: 12,
    VENDOR_ADDR1: null,
    VENDOR_ADDR2: null,
    VENDOR_ADDR3: null,
    VENDOR_ADDR4: null,
    VENDOR_CONTACT: null,
    VENDOR_CODE: null,
    VENDOR_GLOBAL_CODE: null,
    VENDOR_MAIN: null,
    VENDOR_NAME_EN: null,
    VENDOR_NAME_TH: null,
    VENDOR_TYPE: "L",
    NAME_LAST_UPDATE: '',
    LAST_UPD_DATE: null,
    TAX_ID: null,
    VENDOR_EMAIL : null,
    ORDER_CLASS : null,
    ENABLED_FLAG : null

  };


  public DataAdd: any = {

    ADD_STOCK_LEVEL: '0.00',
    AP_SUB_TYPE: null,
    AP_VENDOR_CODE: "XX",
    ATTRIBUTE1: null,
    ATTRIBUTE2: null,
    ATTRIBUTE3: null,
    ATTRIBUTE4: null,
    ATTRIBUTE5: null,
    CALCULATE_PRICE: 'Y',
    COMPANY_CODE: null,
    COUNTRY_CODE: null,
    CPS_FLAG: null,
    CURRENCY_CODE: null,
    ENAME: null,
    FQO_FLAG: "Y",
    GLOBAL_COUNTRY_CODE: null,
    GTOP_STATUS: "N",
    LEAD_TIME_OFF: '0.00',
    LEAD_TIME_ON: '0.00',
    MAPPING_ATTRIBUTE1: null,
    METHOD_ISC: null,
    METHOD_PRICE: null,
    ORDER_INTERVAL: '0.00',
    OVERSEA_FLAG: "D",
    PAYMENT_TERM: 1,
    PAYMENT_TYPE: '2',
    PRICE_TERM_CODE: "N",
    PRINT_PO: "Y",
    PRINT_PRICE: "Y",
    PRINT_STICKER: "Y",
    PRN_PART_FORMAT: null,
    SAP_PAYMENT_TERM: null,
    SK_USER_ID: null,
    SOURCING_CODE: null,
    STD_SAFE_STOCK: '0.00',
    SUGGEST_FLAG: "N",
    TNAME: null,
    TOP_VALUE_ITEMS: 12,
    VENDOR_ADDR1: null,
    VENDOR_ADDR2: null,
    VENDOR_ADDR3: null,
    VENDOR_ADDR4: null,
    VENDOR_CONTACT: null,
    VENDOR_CODE: null,
    VENDOR_GLOBAL_CODE: null,
    VENDOR_MAIN: null,
    VENDOR_NAME_EN: null,
    VENDOR_NAME_TH: null,
    VENDOR_TYPE: "L",
    NAME_LAST_UPDATE: '',
    TAX_ID: null,
    ENABLED_FLAG : "Y"

  };

  public params = {
    VENDOR_CODE: null,
    VENDOR_GLOBAL_CODE: null,
    VENDOR_NAME_TH: null
  }

  public ConfigVendor: any = {
    ColName: "LOOKUP_VENDOR_NAME",
    ColValue: "",
    PlaceholderText: "Select Vendor",
    SourceController: "wPMS",
    SourceMethodName: "GetVendorCode",
    NoOfShowRecords: 30,
    MinLengthSearch: 1,
    UpperCase: true
  }

  public ConfigVendorName: any = {
    ColName: "VENDOR_NAME_TH",
    ColValue: "VENDOR_NAME_TH",
    PlaceholderText: "Select Vendor Name",
    SourceController: "wPMS",
    SourceMethodName: "GetVendorCode",
    NoOfShowRecords: 30,
    MinLengthSearch: 1,
    UpperCase: true
  }

  public ConfigGlobalVendor: any = {
    ColName: "VENDOR_GLOBAL_CODE",
    ColValue: "VENDOR_GLOBAL_CODE",
    PlaceholderText: "Select Global Vendor",
    SourceController: "wPMS",
    SourceMethodName: "GetVendorGlobalCode",
    NoOfShowRecords: 30,
    MinLengthSearch: 1,
    UpperCase: true
  }

  public ConfigSkUser: any = {
    ColName: "LOOKUP_NAME",
    ColValue: "",
    PlaceholderText: "Select Staff",
    SourceController: "wPMS",
    SourceMethodName: "GetSkUser",
    NoOfShowRecords: 30,
    MinLengthSearch: 1
  }

  public ConfigVendorStaff: any = {
    ColName: "LOOKUP_STAFF_NAME",
    PlaceholderText: "Select Vendor Staff",
    SourceController: "wPMS",
    SourceMethodName: "GetVendorUserStaff",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    UpperCase: true
  }

  ngOnInit() {

    this.CheckRole = this.auth.getDetail().ssUserDept == "ACC_C" ? true : false;
    this.CustomerList = [{ ID: 1, CUSTOMER_CODE: "AAA" }, { ID: 2, CUSTOMER_CODE: "BBB" }, { ID: 3, CUSTOMER_CODE: "CCC" }]
    this.Oversea_Flag_List = [{ ID: 'D', TEXT: "D : LOCAL" }, { ID: 'E', TEXT: "E : IMPORT" }]
    this.Vendor_Type_List = [{ ID: 'J', TEXT: "J : Japan" }, { ID: 'K', TEXT: "K : Import(Not Japan)" }, { ID: 'L', TEXT: "L : Local" }, { ID: 'O', TEXT: "O : Oil" }]
    this.Gtop_Status_List = [{ ID: 'Y', TEXT: "Support" }, { ID: 'N', TEXT: "Not Support" }]
    this.Price_TermCode_List = [{ ID: 'C', TEXT: "CIF." }, { ID: 'F', TEXT: "FOB." }, { ID: 'N', TEXT: "LOCAL." }]
    this.GetMaster()
  }

  GetMaster() {
    this.HttpService.get('IC', 'SNM002P_GetMaster')
      .subscribe(res => {
        this.Country_Mater = res.Table;
        this.Vat_Master = res.Table1;
        this.Currency_Master = res.Table2;
        this.Staff_MAster = res.Table3;
        this.OrderClass = res.Table4
      })
  }

  Search() {

    if (!this.Data.VENDOR_CODE) {
      this.modal.info('No data found', this.viewref)
      return;
    }

    this.FlagData = [];
    this.HttpService.get('IC', 'SNM002P_GetVendor', this.Data.VENDOR_CODE)
      .subscribe(res => {
        
        if (res.Table.length > 0) {
          this.FlagData = res.Table
          this.Data = res.Table[0]
          this.qPRINT_PRICE = this.Data.PRINT_PRICE == 'Y' ? true : false;
          this.qPRINT_PO = this.Data.PRINT_PO == 'Y' ? true : false;
          this.qPRINT_STICKER = this.Data.PRINT_STICKER == 'Y' ? true : false;
          this.qCPS_FLAG = this.Data.CPS_FLAG == 'Y' ? true : false;
          this.qMASTER_CHECK = this.Data.VENDOR_MAIN == 'M' ? true : false;
        } else {
          this.modal.info('No data found', this.viewref)
        }

      })

  }



  SearchForAc() {
    this.FlagData = []
    this.Datatable = []

    this.HttpService.post('IC', 'SNM002P_GetVendorForAc', this.params)
      .subscribe(res => {
        this.FlagData = res.Table;
        this.Datatable = res.Table;   //pull db on show
      })

  }
  public Add(){
    this.selection.clear()
    this.dialogAdd.OpenDialog()
  }

  SaveData() {

    this.modal.confirm('Do you want to save changed you have made?', this.viewref, this.ConfirmSaveData)

  }

  ConfirmSaveData = () => {

    this.Data.PRINT_PRICE = this.qPRINT_PRICE == true ? 'Y' : 'N'
    this.Data.PRINT_PO = this.qPRINT_PO == true ? 'Y' : 'N'
    this.Data.PRINT_STICKER = this.qPRINT_STICKER == true ? 'Y' : 'N'
    this.Data.CPS_FLAG = this.qCPS_FLAG == true ? 'Y' : 'N'
    this.Data.VENDOR_MAIN = this.qMASTER_CHECK == true ? 'M' : 'A'
    this.Data.ORDER_CLASS = this.selection.selected.join();


    this.HttpService.post('IC', 'SNM002P_UpdateVendorMaster', this.Data)
      .subscribe(res => {
        if (res.Table[0].STATUS === "Done") {
          this.modal.info('Transaction complete: applied and saved.', this.viewref);
          this.selection.clear();
          this.dialogEdit.Close();
          this.SearchForAc();
        } else {
          this.modal.info('No change to save. Something went wrong.', this.viewref);
        }

      })

  }


  SaveDataAdd() {

    this.modal.confirm('Do you want to save changed you have made?', this.viewref, this.ConfirmSaveDataAdd);
    
  }

  ConfirmSaveDataAdd = () => {

    this.DataAdd.PRINT_PRICE = this.qPRINT_PRICE_ADD == true ? 'Y' : 'N'
    this.DataAdd.PRINT_PO = this.qPRINT_PO_ADD == true ? 'Y' : 'N'
    this.DataAdd.PRINT_STICKER = this.qPRINT_STICKER_ADD == true ? 'Y' : 'N'
    this.DataAdd.CPS_FLAG = this.qCPS_FLAG_ADD == true ? 'Y' : 'N'
    this.DataAdd.VENDOR_MAIN = this.qMASTER_CHECK_ADD == true ? 'M' : 'A'
    this.DataAdd.VENDOR_CODE = this.DataAdd.VENDOR_CODE.toUpperCase()
    this.DataAdd.ORDER_CLASS = this.selection.selected.join();


    this.HttpService.post('IC', 'SNM002P_InsertVendorMaster', this.DataAdd)
      .subscribe(res => {

        if (res.Table[0].STATUS == "Done") {
          this.modal.info('Transaction complete: applied and saved.', this.viewref);
          this.dialogAdd.Close();
          this.ClearDataAdd();
          this.selection.clear()
        } else if (res.Table[0].STATUS == "DUPLICATE") {
          this.modal.info('No change to save. Found dupplicate record.', this.viewref);
        } else {
          this.modal.info('No change to save. Something went wrong.', this.viewref);

        }
      })
  }

  CancelAdd() {
    this.dialogAdd.Close();
  }


  CheckMaster() {


    if (!this.Data.VENDOR_GLOBAL_CODE) {
      this.Data.VENDOR_MAIN = 'A';
      this.Data.VENDOR_GLOBAL_CODE = null;
      this.Data.GLOBAL_COUNTRY_CODE = null;
      this.Data.SOURCING_CODE = null;
      this.Data.GTOP_STATUS = null;
      this.Data.DRG_SUPPLY_CODE = null;

      return false;
    }

    let param = { VENDOR_CODE: this.Data.VENDOR_CODE, VENDOR_GLOBAL_CODE: this.Data.VENDOR_GLOBAL_CODE }
    this.HttpService.post('IC', 'SNM002P_CheckMasterGlobal', param)
      .subscribe(res => {

        if (res.Table) {
          this.qMASTER_CHECK = false;
          let message = res.Table[0].MESSAGE

          this.modal.warning(message, this.viewref);

        }
      })


  }


  CheckMasterForAdd() {


    if (!this.DataAdd.VENDOR_GLOBAL_CODE) {
      this.DataAdd.VENDOR_MAIN = 'A';
      this.DataAdd.VENDOR_GLOBAL_CODE = null;
      this.DataAdd.GLOBAL_COUNTRY_CODE = null;
      this.DataAdd.SOURCING_CODE = null;
      this.DataAdd.GTOP_STATUS = null;
      this.DataAdd.DRG_SUPPLY_CODE = null;

      return false;
    }

    let param = { VENDOR_CODE: this.DataAdd.VENDOR_CODE, VENDOR_GLOBAL_CODE: this.DataAdd.VENDOR_GLOBAL_CODE }
    this.HttpService.post('IC', 'SNM002P_CheckMasterGlobal', param)
      .subscribe(res => {

        if (res.Table) {
          this.qMASTER_CHECK_ADD = false;
          let message = res.Table[0].MESSAGE

          this.modal.warning(message, this.viewref);

        }
      })


  }

  ValidateNumberEdit(oldvalue, newvalue, key) {

    if (key == 'STD_SAFE_STOCK') {
      if (Number(this.DataAdd.STD_SAFE_STOCK) < 0 || Number(this.Data.STD_SAFE_STOCK) > 99999.99) {
        this.modal.warning('Field must be of form 99990.99', this.viewref)
        this.Data.STD_SAFE_STOCK = parseInt((Number(oldvalue) * 100).toString()) / 100 //Number(oldvalue).toFixed(2);
        // return false;
      } else {
        this.Data.STD_SAFE_STOCK = parseInt((Number(newvalue) * 100).toString()) / 100 //Number(newvalue).toFixed(2);
      }
    } else {
      if (Number(this.DataAdd[key]) < 0 || Number(this.Data[key]) > 9.99) {
        this.modal.warning('Field must be of form 9.99', this.viewref)
        this.Data[key] = parseInt((Number(oldvalue) * 100).toString()) / 100 //Number(oldvalue).toFixed(2);
      } else {
        this.Data[key] = parseInt((Number(newvalue) * 100).toString()) / 100 //Number(newvalue).toFixed(2);
      }
    }
  }

  ValidateNumberAdd(oldvalue, newvalue, key) {

    if (key == 'STD_SAFE_STOCK') {
      if (Number(this.DataAdd.STD_SAFE_STOCK) < 0 || Number(this.DataAdd.STD_SAFE_STOCK) > 99999.99) {
        this.modal.warning('Field must be of form 99999.99', this.viewref)
        this.DataAdd.STD_SAFE_STOCK = parseInt((Number(oldvalue) * 100).toString()) / 100 //Number(oldvalue).toFixed(2);
      } else {
        this.DataAdd.STD_SAFE_STOCK = parseInt((Number(newvalue) * 100).toString()) / 100 //Number(newvalue).toFixed(2);
      }
    } else {
      if (Number(this.DataAdd[key]) < 0 || Number(this.DataAdd[key]) > 9.99) {
        this.modal.warning('Field must be of form 9.99', this.viewref)
        this.DataAdd[key] = parseInt((Number(oldvalue) * 100).toString()) / 100 //Number(oldvalue).toFixed(2);
      } else {
        this.DataAdd[key] = parseInt((Number(newvalue) * 100).toString()) / 100 //Number(newvalue).toFixed(2);
      }
    }
  }

  CallBack(event) {
    this.params.VENDOR_CODE = event.VENDOR_CODE
    //this.VENDOR_NAME = event.VENDOR_NAME_TH
  }

  SelectedStaff(event) {
    this.Data.SK_USER_ID = event.STAFF_ID
    this.Data.ENAME = event.ENAME
    this.Data.TNAME = event.TNAME
    //this.VENDOR_NAME = event.VENDOR_NAME_TH
  }

  SelectedStaffAdd(event) {
    this.DataAdd.SK_USER_ID = event.STAFF_ID
    this.DataAdd.ENAME = event.ENAME
    this.DataAdd.TNAME = event.TNAME
  }

  EditRow(row) {
    this.selection.clear();
    if(row.ORDER_CLASS){
      this.selection.select(...row.ORDER_CLASS.split(','))
    }
    this.Data = row;

    this.qPRINT_PRICE = this.Data.PRINT_PRICE == 'Y' ? true : false;
    this.qPRINT_PO = this.Data.PRINT_PO == 'Y' ? true : false;
    this.qPRINT_STICKER = this.Data.PRINT_STICKER == 'Y' ? true : false;
    this.qCPS_FLAG = this.Data.CPS_FLAG == 'Y' ? true : false;
    this.qMASTER_CHECK = this.Data.VENDOR_MAIN == 'M' ? true : false;


    this.dialogEdit.OpenDialog()
  }

  CancelEdit() {
    this.dialogEdit.Close();
  }



  Delete() {

    this.HttpService.get('IC', 'SNM002P_ValidateDelete', this.Data.VENDOR_CODE)
      .subscribe(res => {
        if (res.Table[0].STATUS == 0) {
          this.modal.warning(res.Table[0].MESSAGE, this.viewref)
        } else {
          this.modal.confirm(res.Table[0].MESSAGE, this.viewref, this.ConfirmDelete)
        }
      })

  }

  ConfirmDelete = () => {

    this.HttpService.get('IC', 'SNM002P_Delete', this.Data.VENDOR_CODE)
      .subscribe(res => {
        if (res.Table[0].STATUS === "DONE") {
          this.modal.info('Transaction complete: 1 record applied and deleted.', this.viewref);
        } else if (res.Table[0].STATUS === "NO_DATA") {
          this.modal.warning('No data found', this.viewref);
        } else {
          this.modal.warning('No change to save. Something went wrong.', this.viewref);
        }
      })
  }

  Download() {

    this.HttpService.Download('IC', 'SNM002P_Download',this.params)
      .subscribe(res => {
        if (res) {
          this.WriteContents(res)
        } else {
          this.modal.error('Export file not complete', this.viewref)
        }

      },err => {
        this.modal.error('Export file not complete', this.viewref)
      })
  }

  WriteContents(content) {
    const a = document.createElement('a');
    const file = new Blob([content], { type: content.type });
    a.href = URL.createObjectURL(file);
    a.download = "VendorInfo.xlsx";
    a.click();
  }

  Clear() {
    this.Data.ADD_STOCK_LEVEL = '0.00'
    this.Data.AP_SUB_TYPE = null
    this.Data.AP_VENDOR_CODE = "XX"
    this.Data.ATTRIBUTE1 = null
    this.Data.ATTRIBUTE2 = null
    this.Data.ATTRIBUTE3 = null
    this.Data.ATTRIBUTE4 = null
    this.Data.ATTRIBUTE5 = null
    this.Data.CALCULATE_PRICE = 'Y'
    this.Data.COMPANY_CODE = null
    this.Data.COUNTRY_CODE = null
    this.Data.CPS_FLAG = null
    this.Data.CURRENCY_CODE = null
    this.Data.ENAME = null
    this.Data.FQO_FLAG = "Y"
    this.Data.GLOBAL_COUNTRY_CODE = null
    this.Data.GTOP_STATUS = "N"
    this.Data.LEAD_TIME_OFF = '0.00'
    this.Data.LEAD_TIME_ON = '0.00'
    this.Data.MAPPING_ATTRIBUTE1 = null
    this.Data.METHOD_ISC = null
    this.Data.METHOD_PRICE = null
    this.Data.ORDER_INTERVAL = '0.00'
    this.Data.OVERSEA_FLAG = "D"
    this.Data.PAYMENT_TERM = 1
    this.Data.PAYMENT_TYPE = '2'
    this.Data.PRICE_TERM_CODE = "N"
    this.Data.PRINT_PO = "Y"
    this.Data.PRINT_PRICE = "Y"
    this.Data.PRINT_STICKER = "Y"
    this.Data.PRN_PART_FORMAT = null
    this.Data.SAP_PAYMENT_TERM = null
    this.Data.SK_USER_ID = null
    this.Data.SOURCING_CODE = null
    this.Data.STD_SAFE_STOCK = '0.00'
    this.Data.SUGGEST_FLAG = "N"
    this.Data.TNAME = null
    this.Data.TOP_VALUE_ITEMS = 12
    this.Data.VENDOR_ADDR1 = null
    this.Data.VENDOR_ADDR2 = null
    this.Data.VENDOR_ADDR3 = null
    this.Data.VENDOR_ADDR4 = null
    this.Data.VENDOR_CONTACT = null
    this.Data.VENDOR_CODE = null
    this.Data.VENDOR_GLOBAL_CODE = null
    this.Data.VENDOR_MAIN = null
    this.Data.VENDOR_NAME_EN = null
    this.Data.VENDOR_NAME_TH = null
    this.Data.VENDOR_TYPE = "L"
    this.Data.NAME_LAST_UPDATE = ''
    this.Data.LAST_UPD_DATE = ''
    this.Data.TAX_ID = null
    this.Data.VENDOR_EMAIL = null
    this.Data.ORDER_CLASS = null
    this.Data.ENABLED_FLAG = null
    this.FlagData = [];
  }


  ClearDataAdd() {
    this.DataAdd.ADD_STOCK_LEVEL = '0.00'
    this.DataAdd.AP_SUB_TYPE = null
    this.DataAdd.AP_VENDOR_CODE = "XX"
    this.DataAdd.ATTRIBUTE1 = null
    this.DataAdd.ATTRIBUTE2 = null
    this.DataAdd.ATTRIBUTE3 = null
    this.DataAdd.ATTRIBUTE4 = null
    this.DataAdd.ATTRIBUTE5 = null
    this.DataAdd.CALCULATE_PRICE = 'Y'
    this.DataAdd.COMPANY_CODE = null
    this.DataAdd.COUNTRY_CODE = null
    this.DataAdd.CPS_FLAG = null
    this.DataAdd.CURRENCY_CODE = null
    this.DataAdd.ENAME = null
    this.DataAdd.FQO_FLAG = "Y"
    this.DataAdd.GLOBAL_COUNTRY_CODE = null
    this.DataAdd.GTOP_STATUS = "N"
    this.DataAdd.LEAD_TIME_OFF = '0.00'
    this.DataAdd.LEAD_TIME_ON = '0.00'
    this.DataAdd.MAPPING_ATTRIBUTE1 = null
    this.DataAdd.METHOD_ISC = null
    this.DataAdd.METHOD_PRICE = null
    this.DataAdd.ORDER_INTERVAL = '0.00'
    this.DataAdd.OVERSEA_FLAG = "D"
    this.DataAdd.PAYMENT_TERM = 1
    this.DataAdd.PAYMENT_TYPE = '2'
    this.DataAdd.PRICE_TERM_CODE = "N"
    this.DataAdd.PRINT_PO = "Y"
    this.DataAdd.PRINT_PRICE = "Y"
    this.DataAdd.PRINT_STICKER = "Y"
    this.DataAdd.PRN_PART_FORMAT = null
    this.DataAdd.SAP_PAYMENT_TERM = null
    this.DataAdd.SK_USER_ID = null
    this.DataAdd.SOURCING_CODE = null
    this.DataAdd.STD_SAFE_STOCK = '0.00'
    this.DataAdd.SUGGEST_FLAG = "N"
    this.DataAdd.TNAME = null
    this.DataAdd.TOP_VALUE_ITEMS = 12
    this.DataAdd.VENDOR_ADDR1 = null
    this.DataAdd.VENDOR_ADDR2 = null
    this.DataAdd.VENDOR_ADDR3 = null
    this.DataAdd.VENDOR_ADDR4 = null
    this.DataAdd.VENDOR_CONTACT = null
    this.DataAdd.VENDOR_CODE = null
    this.DataAdd.VENDOR_GLOBAL_CODE = null
    this.DataAdd.VENDOR_MAIN = null
    this.DataAdd.VENDOR_NAME_EN = null
    this.DataAdd.VENDOR_NAME_TH = null
    this.DataAdd.VENDOR_TYPE = "L"
    this.DataAdd.NAME_LAST_UPDATE = ''
    this.DataAdd.VENDOR_EMAIL = null
    this.DataAdd.ORDER_CLASS = null
    this.DataAdd.TAX_ID = null
    this.DataAdd.ENABLED_FLAG = 'Y'
  }
}
